/*
   This is the main program.
   
   speed diff between noSBase and SBase & sym_k=-1000 signifikant ?
   dann ohne sym beseitigen! less code

    save "kgV" of all sym.l?, hxy as (zahl betrag, int=tphase phase)
    better as (zahl real,zahl imag)? vector v=sum phase*real

   ToDo: Simplify the program to make the code better readable!!!! C++!!!

   startvec = \sum_j c^+_{i_j,s} ... |0> = 4u 2d 3u |0>    
   
   complex? phase factor later added during computation of H(i,j)
    multiply phase to base in a way that Hamiltonian and Vector is reell!?

   set parameters
   <OP> as pointer of OP-function
   static int (*a)(int b); o.ae.

   tU -> ...u..u. * ..d..d divide into up and down part (2 tables)   
   tJ -> ...uu... ...--d.d => (N over u)*(N-u over d)
   JJ -> ...
   
   operation x<<32 leads to errors for 32bit (no shift)
  
   result of (~0)>>1==~0 != (~0u)>>1  depends on compiler?
   
*/

#include "version.h"
#include "block.h"
#include "spins.h"
#include "tbase.h"
#include "ansatz.h"
#include "pipe.h"
#include "vector.h"
#ifdef CONFIG_PTHREAD   /* ToDo: movto mthreads.h */
#include <pthread.h>
pthread_attr_t pt_attr;  /* SunOS has SCOPE_PROCESS as default, we need SCOPE_SYSTEM */
pthread_cond_t pt_cond1;  /* conditions master -> childs */
pthread_cond_t pt_cond2;  /* conditions childs -> master */
pthread_mutex_t pt_mutex1; /* mutex */
pthread_mutex_t pt_mutex2; /* mutex */
#endif
#ifdef CONFIG_MPI
#include <mpi.h>
#endif

#define Korrelations 1  /* 1=mit 0=ohne Spin-Korrelationen */
#if 1
#define Method 2	/* Method=2: store norm2(sbase) if you can */
#endif

#ifndef Ham1
#define Ham1	1	/* SiSj - ninj/4 + (ham1)?ninj/4:0 */          
#endif
#ifndef Ham2            /* results differ in U*(N/4-(nu+nd)/2) */
#define Ham2	0	/* 0 = U nu nd ,  1 = U(nu-.5)(nd-.5) */
#endif
#ifndef Ham3
#define Ham3	0	/* 0 = ohne ... , 1 = mit JH-Oles-Term cc und cpcp */
#endif 


#include "spinstri.h"	/* spinstri.c::outtri() */
#include "mem.h"	/* mymalloc();myfree() */
#include "symmetry.h"	/* lattice symmetries */
#include "diag.h"
#include "myprint.h"	/* maple-Ausgabe */
#include "xval.h"	/* expectation values */
#include "h_file.h"	/* read/write Hamilton matrix on Htmp */
#include "error.h"	/* err_fatal */
#include "hilbert.h"
#include "modeldef.h"

#ifndef Add34
#define Add34 0.0	/* SiSj+Add34*ninj shifting energy, default is 0.0 */
			/* may be +0.75 or -0.25 (or +0.25) is a good idea */
#endif

#define vnul ((tvec *)NULL)	/* use as NULL */
/* against egcs-2.90.29 980515 (egcs-1.0.3 release)
 * warning: initialization of non-const reference "class a_cplx &" from rvalue "a_cplx" */
double  h_xypara=1.0;
double  h_zpara=1.0;	/* H=h_zpara*SizSjz+h_xypara*(SixSjx+SiySjy),
				 z-anisotropy Feb99, xy Jun99 */
int     algo;		/* 0=lanzcos,1=richter,2=wenzel2x2 */
int     save_mode=0; 	/* 1=setup after crash possible, 2=continue */
int     checkpoint=0;   /* checkpoint for crash status */
int	pew;		/* number eigenvalue to check */
int	max_ea;		/* max. zu messender Entartungsgrad */
int     x_p;		/* Darstellungsform fuer |x> <=3 */
ULong	n1,n2;		/* Matrixsize , Linsize      */
zahl ew[NEW];		/* Eigenwerte     (max 4)	*/
ULong  *l2b;		/* Hilfs-Tabellen storeh2 */
ATnorm2 *norm2=NULL;	/* vector idx->sym-idx, norm(sym-idx)	*/
minfo_t m_n2 = {NULL,0,0,"tmp/n2.map",NULL}; /* norm2 companion */
int base2ok=0;			/* flag: norm2 not yet inititialized */
ULong hfmax;			/* max. num of hxy[]-elements on disk	*/
#if 0
FILE *hfile,*fhxy1,*fhxy2;	/* File enthaelt Hamiltonien		*/
#endif
ULong usemem,maxmem;		/* maximaler speicher -> no paging!	*/
int  startvec=4;		/* 0:rand(iv), 1:v[iv]=1, 2:v=file! 
				   3:v=intxtfile 4:rand */
/* used for marshall rule (mrule) */
#define NSL 8			/* maximum number SL-definitions */
int num_sublat=0;		/* number of used SL-definitions */
int sublat[NSL][NN];		/* buffer for SL-definitions */

int cfg_sisj;	/* option for correlations, bit0=SiSj bit1=SS bit2=ZiZj(?) */

tbase1 p_mask[NN][NN];		/* bit masks for parity()  */


/* local variables for pthreads */
typedef struct {
  int num;     /* to identify itself (ro) */
  void *data;  /* to send data-block (set by thread 0, read by workers) */
  int  task;   /* thread 0 sets 1 to run worker, worker sets 0 if ready */
  void (*worker)(void *data); /* parallel working function */
  /* mutex for each thread? */
} main_pts;
volatile main_pts main_pt[B_NUM]; /* [un]locked by mutex1 */

#ifdef CONFIG_PTHREAD
/* send jobtype (task) to threads and restart them */
void parallel_start( int thread_i, void (*worker)(void *data), void *data ){
    pthread_mutex_lock(&pt_mutex1);
    main_pt[thread_i].task=1; /* run worker */
    main_pt[thread_i].data=data;
    main_pt[thread_i].worker=worker;
    /* ToDo: do next only once after storing all tasks
             or send signal only to the job */
    pthread_cond_broadcast(&pt_cond1); /* data send to threads */
    pthread_mutex_unlock(&pt_mutex1);
}

/* waiting for threads */
void parallel_wait( int thread_i ){
    pthread_mutex_lock(&pt_mutex1);
    while ( main_pt[thread_i].task )  
      pthread_cond_wait(&pt_cond2,&pt_mutex1); /* wait for child */
    pthread_mutex_unlock(&pt_mutex1);
}
#else /* dummy parallel functions (serialized pthreads) */
void parallel_start( int thread_i, void (*worker)(void *data), void *data ){
  worker(data); }
void parallel_wait( int thread_i ){}
#endif

/* spins.h: inline zahl norm(zahl r){return(r*r);} */
char *sclock(long t){  /* 0..960s 16m..960m 16h... => 00:00:00 */
   static char s[24];if(t==~0l)t=itime();
   sprintf(s,"%02ld:%02ld:%02ld",t/3600,(t/60)%60,t%60);
#if 0
   if(t>16*60*60l)sprintf(s,"%ldh",t/ 3600); else
   if(t>   16*60l)sprintf(s,"%ldm",t/   60); else sprintf(s,"%lds",t); 
#endif
   return(s);}

char *outc(cplx r){  /* complexe zahl */    
    static char s1[100];
#if VecType & 4
    /* sprintf(s1,"(%g,%g)",real(r),imag(r)); */
    sprintf(s1,"%12.9f*exp(%+9.6f*I*Pi)",fabs(r),arg(r)/M_PI);
#else
    sprintf(s1,"% 12.9f",D(r));		/* 12.9f or 16.9e */
#endif
    return(s1);}

char *outc2(cplx r){  /* complexe zahl */    
    static char s1[100];
#if VecType & 4
    /* sprintf(s1,"(%g,%g)",real(r),imag(r)); */
    sprintf(s1,"%12.9e*exp(%+9.6f*I*Pi)",fabs(r),arg(r)/M_PI);
#else
    sprintf(s1,"% 12.9e",D(r));		/* 12.9f or 16.9e */
#endif
    return(s1);}

char *outphase(tphase r){  /* complexe zahl oder integer */    
    static char s1[100];
#if VecType & 4
    /* sprintf(s1,"+(% g,% g)",real(r),imag(r)); */
    sprintf(s1,"%6.3f*exp(%+6.3f*I*Pi)",fabs(r),arg(r)/M_PI);
#else
    sprintf(s1,"%+d",r); 
#endif
    return(s1);}

void nl(FILE *f){ fprintf(f,"\n");return;}
/* output eigenvalues */
void outew(FILE *f){
   int k;
   for (k=0;k<NEW;k++) fprintf(f," %12.8f",(double)ew[k]);
   return;
}


/* ---------------------------------------------------- *
 *      hamiltonien untersuchen (sym,num_nz,...)	*
 *	-	-	-	-	-	-	*/
#define Nnzx 100	/* max. Anzahl NZ in H-Zeile 	*/

struct tchkh {    
      zahl eps;		/* genauigkeit 1e-14 float 		*/ 
      zahl min;		/* kleinste zahl groesser eps 		*/
      ULong nznd;	/* anzahl nicht-diagonal elemente > eps	*/
      ULong nzd;	/* anzahl diagonal elemente > eps 	*/
      ULong nzxmax;	/* max. anzahl elemente > eps in einer zeile */
      ULong z0;		/* anzahl elemente |r| == 0 		*/
      ULong zeps;	/* anzahl elemente |r| <=  eps 		*/
      ULong ncplx;	/* anzahl complexer h's			*/
      cplx sum12[B_NUM],
           sum21[B_NUM];  /* sum-upperright,lowerleft (same!) */
      double hh12[B_NUM],
             hh21[B_NUM]; /* sum-upperright,lowerleft (same!) */
      double traceH[B_NUM];  /* Trace of H */
      /* 
          gleiche Zeilen? -> xyh.tmp xny.tmp
          anzahl verschiedene entrys?
      */ 
      } 
      chkh;/* = {1e-14,1e+14,0l,0l,0l,0l,0l,0l,C(0,0),C(0,0)};
            * Fehler mit gcc -xc++ v2.7.0 auf HP9000, Oct99 */
            
void chkhxyini(){
 int i;
 chkh.eps=1e-14;
 chkh.min=1e+14;
 chkh.nzd=0l;
 chkh.nznd=0l;
 chkh.nzxmax=0l;
 chkh.z0=0l;
 chkh.zeps=0l;
 chkh.ncplx=0l;
 for(i=0;i<B_NUM;i++){
   chkh.sum12[i]=C(0,0);
   chkh.sum21[i]=C(0,0);
   chkh.hh12[i]=0.0;
   chkh.hh21[i]=0.0;
   chkh.traceH[i]=0.0;
 }
}
/* this function does not conform to MP ??? */
void chkhxy(ULong x,int blk,ULong y,cplx r){/* 0=start,1=loop,2=last(print) */
  static ULong lastx=~0l,lnzx=0l; double rr;
  if(vvv&32)if(x<x_max){	/* max. x_max H-Zeilen ausgeben */
    if (x==0 && lnzx==0) printf("\n vvv&32, output max=%ld lines:",x_max);
/* if(fabs(r)!=0.0) */
    /* printf("\n x=%8lu y=%8lu h_xy=%s",x,y,outc(r)); --- old --- */
    { printf("\n addh(%5lu,%5lu, ",x,y);
#if VecType & 4
      outmpl(stdout,Re(r));printf(",");
      outmpl(stdout,Im(r));			/* +(a/b)^(1/2) */
#else
      outmpl(stdout,D(r));			/* +(a/b)^(1/2) */
#endif
      printf("):"); }				/* for maple */
  }
  if(x>y) chkh.sum12[blk]+=r;		/* summe of half H's */
  if(x<y) chkh.sum21[blk]+=r;		/*   should be conjugated value */
  if(x>y) chkh.hh12[blk]+=Norm(r);	/* summe of half H's */
  if(x<y) chkh.hh21[blk]+=Norm(r);	/*   should be same */
  if(x==y) chkh.traceH[blk]+=Re(r);	/* should be base invariant */
  if(x!=lastx){lnzx=0l;lastx=x;}	/* neue zeile */
  rr=fabs(r);				/* cmplx => real */
  if(D(r)!=r) chkh.ncplx++;		/* Mai 99 */
  if(rr>chkh.eps){
      lnzx++;if(lnzx>chkh.nzxmax)chkh.nzxmax=lnzx;
      if(rr<chkh.min)chkh.min=rr;
      if(x!=y)chkh.nznd++;else chkh.nzd++; }
  else { if(rr==0.0)chkh.z0++; chkh.zeps++; }
  return;}
void chkhnl(){					/* new line x */
   return;}
void outhxy(){		/* output statistics vvv&2 */
  int i;
  cplx sum12,sum21;
  double hh12,hh21,traceH;
  sum12=sum21=hh12=hh21=traceH=0;
  for(i=0;i<B_NUM;i++){
    sum12+=chkh.sum12[i];
    sum21+=chkh.sum21[i];
    hh12+=chkh.hh12[i];
    hh21+=chkh.hh21[i];
    traceH+=chkh.traceH[i];
  }
  printf("\n vvv&2 statistics for H:");
  printf("\n h_min>eps      : %.4e ,   eps    : %.0e", D(chkh.min),D(chkh.eps));
  printf("\n h_nz_ndiag>eps : %10lu ,   h==0.0 : %10lu",chkh.nznd,chkh.z0);
  printf("\n h_nz_diag>eps  : %10lu ,   h<=eps : %10lu",chkh.nzd,chkh.zeps);
  printf("\n h_nz_x_max>eps : %10lu ,   h_cplx : %10lu",chkh.nzxmax,chkh.ncplx);
  printf("\n trace of H     : %16.9e", traceH);
  printf("\n sum_h12   hh12 : %s %.8e", outc2(sum12), hh12);
  printf("\n sum_h21   hh21 : %s %.8e", outc2(sum21), hh21);
  printf("\n sum h21-h12^*  : %s %.8e", outc2(sum21-Conj(sum12)), hh21-hh12);
  if(    fabs(sum12 -Conj(sum21))
  >1e-8*(fabs(sum12)+fabs(sum21)) ) E0("H not hermitian");
}
/* --------------------------------------------------------------- */  

/* moved from h_file.c near to the caller (CPU cache) */
/* store a matrix element (xy=yindex,r=value) into the file buffer b_hbl
 * (one buffer for each thread) and write to a file if buffer is full,
 * buffer and file size is expensive, try to spare
 * block = [blk,by] is coded as blk*B_NUM+by (v2.25)
 * ToDo: write blk,by,xstart,ystart,[{r,y},...]
 * if (!STORE_XandY) only first xx of each block is stored
 * Jan07 no significant speedup if moved to spins.c and inlined
 */
// static inline 
void h_put(int block,ULong xx,ULong xy,cplx r){
  int tb=block;
  HR_TYPE rr;
#if HRMAX>0                 /* use a index table to spare disk place */
    /* store if not already stored, get index else */
    unsigned int j;
    /* Note: Norm(hr-r)<1e-13 can fail for some systems, */
    /*       but hr==r is probably unecessary strong (1.234567!=1.234566) */
    for(j=0;j<hr_len[block];j++) if(Norm(hr[block][j]-r)<=1e-13) break;
    /* here we should store max(hr[][]-r)<1e-13, but this takes time */
    if(j>=hr_len[block])	/* not found */
    {
       hr[block][j]=r; hr_len[block]++;
       if(hr_len[block]>=HRMAX) err_fulltable(); /* OVL */
    }
    rr=(HR_TYPE)j;		/* store index to value */
#else    
    rr=M_d2f(r);		/* store value direct */
#endif    
    /*
     *   b_hnz  - number of hamilton-elements per compute block
     *   hmax  - memory space for h
     *   hfmax - file space for h per block
     *    replace this part, use own = to spare mem (3int type etc)
     */
    if( b_hnz[block]<hfmax ){	/* store */
      b_hbuf[tb].r[  b_hbl[tb] ]=rr;
      b_hbuf[tb].xy[ b_hbl[tb] ]=(XY_TYPE)xy;
#ifdef STORE_XandY
      b_hbuf[tb].xx[ b_hbl[tb] ]=(XY_TYPE)xx;
#else
      if (!b_hbl[tb]) b_hbuf[tb].xx=(XY_TYPE)xx; /* first xx of block */
      /* ToDo: transparent adding of xy flag if x+1? */
#endif
      /* store in Hblock-buffer */
      b_hbl[tb]++;
      if(b_hbl[tb]>=HBLen){   /* flush buffer to disk-file */
        // printf(" hwrite %d",block);
        if (h_state[block]!=2) ERR(9999); /* file not open */
        b_hbuf[tb].block=block; /* store blk for planed async version */
        if (vvv&16)
          printf("\nvvv&16 blk %2d h_write", block);
        if (my_fwrite((void *)&b_hbuf[block],Hsize,1,block%F_NUM)!=1) {
          ERR(620); h_error=1; return; 
        }
        b_hbl[tb]=0;
      }
      b_snz[block]++;
    }
    if(  b_hnz[block]==hfmax) ERR(630); /* maxfile reached, stop writing */
    if(  b_hnz[block]+1) b_hnz[block]++;
    if(!(b_hnz[block]+2))     ERR(610); /* counter overflow */
}



/* see .h */
/*  thbuf *buf1; buf1=alloc_hbuf(); ... free_hbuf(buf1); */
thbuf *alloc_hbuf(){ 
  thbuf *buf;
  /* ToDo: dynamic mem alloc for hbuf->el if needed */
  buf=(thbuf *)mymalloc( sizeof(thbuf), NULL); /* no msg,  */
  buf->n=0;	/* ini num_elements_in_buf */
  buf->block=-1;  /* line belongs to block-nr, -1 means unused */
  return buf;
}
void *free_hbuf( thbuf *pb ){ return myfree( (void *) pb, NULL ); }
/*    ------------------------------------------
     error handling seperated from normal routine,
     which should fit in the cpu-cache
 */
void nhm_err1( ULong i, tbase kj,
         struct sbase *bi,	/* symkfg(bi) */
         struct sbase *bj){	/* buffer for symkfg(bj) */
    static int anz=0;
    tbase kj2;
    anz++;
    if (anz<32) { /* avoid excessiv output */
      E2("nhm %s skfg i=%lu",ckfg(bi->skfg),i);
      E2("nhm %s orig err_fatal=%d",ckfg(kj ),err_fatal);
    }
    kj2=b_smallest(kj,bj);
    if (anz<32) {
      E2("nhm %s b2i=%lu (smallest)",ckfg(kj2),(unsigned long)b2i(kj2));
      b_out(bi,0);
      b_out(bj,0); 
      printf(" try getbase ...");
      bj->o=1*0;b_getbase(kj,bj);bj->o=0;
      b_out(bj,0); printf(" b2i=%ld n1=%ld",(long)b2i(bj->skfg),(long)n1);
    }
    b2i_if_err(bj->skfg);
    if (anz==32) printf(" Warning nhm_err1: output stopped.\n");
}

/* -----------------------------------
 * r*(kj|kj><kj|ki) hbuf->bi,bj ??? 
 *   learn from puthbuf(), better???
 * m1=mode:
 *  0: <n|H*v0> + <n|H*n> v0=may used (if v0!= 0) only for m1==0 
 *  2: storeh, used in hamilton_nhv, v0=0
 *  4: buf_..=H|n> without_sym+idx called by storeh2, v0=0 (l1 empty!)
 *  8: buf_..=H|n> full            called by fulldiag to get el.j+r, v0=0
 * v0=vector used only if !vnul and m1==0
 * ToDo: do we need v0? move v0, bi, bj(?) into hbuf!
 * ToDo: set hbuf.el[0] always to the diagonal element? what about r==0?
 * ----------------------------------------------------------- */
cplx nhm(tbase kj,cplx r,tvec *v0,thbuf *hbuf,int m1,
         struct sbase *bi,	/* symkfg(bi) = input */
         struct sbase *bj){	/* buffer for symkfg(bj) */
  ULong j=0; tbase kj2=kj; int ii,blk;
  if (r==0) return (0);  /* 32+8: 7/135s */
#ifdef CONFIG_ANSATZ
  if (!ansatz_test(kj)) return (0); /* ToDo: extra call after buffer filled? */
#endif
  if (!(m1&4)) {  /* for m1&4 l1 is not ready for use */
#ifdef SBase                  /* r*=(i|kj) */
    j=hbuf->i;        /* index of configuration, where H is acting on */
    if (bi->skfg!=kj) { /* 34+6: true=24e3/533e3 speedup=5s/107s */ 
      /* j=b2i(kj); */ /* +10%CPU 28+8 */
      /* faster v2.25 code removed, simplify, better make b_smallest faster */ 
      bj->o=0;
      /* b_smallest: 34+6 calls(34+6)=509286/(nhm=533625) 98s/(nhm=102s) */
      kj2=b_smallest(kj,bj);  /* 107/135s, block operation? */
      if (phase_eq(bj->sign,0)) return(0); r*=bj->sign; /* statistic how often? */
      if (!(bi->skfg==kj2)) j=b2i(kj2);  /* 8/135s how often? -pg */
      /* kj!=ki */
      if(err_fatal || j>=n1){ nhm_err1(hbuf->i,kj,bi,bj);err_fatal=0;j=b2i(bj->skfg); }
      /* 135/135s */
      if(bi->norm2!=bj->norm2)
         r*=sqrt((double)bi->norm2/(double)bj->norm2);  /* count? table? */
      /* printf("\n%s\n%s\n i=%d j=%d r=% f %+d",ckfg(bi->skfg),ckfg(kj),(int)i,(int)j,r,bj->sign); */
      /* 135/135s */
    }
#else
    if (bi->skfg==kj2) { j=hbuf->i; } else j=b2i(kj2);
#endif
    if (j>=n1) return 0; /* err_fatal, kfg not found, dont happens!? */
    if (bi->skfg==kj2) { hbuf->nhn+=D(r); } /* fail for complex Hii */
    // if (nn==6) printf(" [%lu %lu] %f %f \n %s\n %s\n",hbuf->i,j,r,hbuf->nhn,ckfg(bi->skfg),ckfg(kj));
  }
  if (m1&(2+4+8))
  { /* use n<0 as flag? for storing to hbuf? */
    /* obsolete: subblock blk = b_getnum(j); */
    /* ToDo: what happens for m1&4 ??? put all data in first block! */
    hbuf->el[hbuf->n].r=r;    /* fill buffer */
    hbuf->el[hbuf->n].kj=kj;
    hbuf->el[hbuf->n].j=j;
    /* data compression, (better after buffer filled? using hashing, trees or lists?)
     * comparing j is faster (long) than comparing kj (tbase)
     * but m1&4 (storeh2) dont have j set and testing m1&4 is slow too */
    for (ii=0;ii<hbuf->n;ii++)
      if (hbuf->el[ii].kj==kj) break;
    /* same idx found - sort ! */
    if(ii==hbuf->n){ hbuf->n++;  if (hbuf->n>=NZXMAX) ERR(9200); }
    else           { hbuf->el[ii].r+=r; } /* sq30+10: old/new=1e-3 */
  } 
  if(v0!=vnul && !(m1&(2+4+8))){ /* we only need <nHv> */
    /* here we use m1==0 to get nHv for iteration process (fast) */
    blk=b_getnum(j); r*=M_f2d(v0->v[blk][j-b_ofs[blk]]);
  }
  return(r);
} 


/* store elements of one H-line to the HBlock files on disk */
/* ToDo: use CPU-cache for lin
 *      - if cache filled, return buffered line
 *      - if cache empty, fill it
 * input: hbuf.i + hbuf.n + hbuf.el[0..n-1]
 * output: H-file + Statistics
 */
void nhmline(thbuf *hbuf){
  int ii, blk; ULong b_snz_old;
  blk=hbuf->block;
  /* store old status, restore if write fails */
  b_snz_old = b_snz[blk];
  /* to get the geth function working correctly, we need minimum 1 entry
   * per line. If necessary we store a dummy 0 element */ 
  if(hbuf->n==0){ h_put(blk,hbuf->i,XY_FLAG,0); }
  else {
    if (vvv&2) for (ii=0;ii<hbuf->n;ii++)
      chkhxy(hbuf->i,blk,hbuf->el[ii].j,hbuf->el[ii].r);
    hbuf->el[hbuf->n-1].j|=XY_FLAG; /* mark next line at end */
    for(ii=0;ii<hbuf->n;ii++)
        /* write via buffer */
        h_put(blk, hbuf->i, hbuf->el[ii].j, hbuf->el[ii].r);
    hbuf->n=0;		/* new line! */
  }
  /* check if all elements of this matrix line have been stored */
  if (  b_hnz[blk] == b_snz[blk] ) b_sn1[blk]++;  /* Hline stored successfully */
  else  b_snz[blk] =  b_snz_old;
  return;
}


/* ----------------------------------------------------------------
 * m1=mode: 0=<n|H*v0> (return nhn too)
 *          1=<n|H*n>   obsolete! used for 2x2-algo
 *            until v2.25 for uududd==uuddud <nHn>=0, but its != 0
 *            result correct? differences? 3+3 diverged (n1=3)
 *  uuuddd/q6, uududd/q12, ududud/q2
 *  [1/2, q(1/2), 0] [q(1/2), 1/2, q(3/2)] [0, q(3/2), -3/2] trace=-1/2
 *  nhn_old: 1/2 -1/2 -3/2      e0=nan
 *  nhn_new: 1/2  1/2 -3/2  8It e0=-2.118033988749896
 * m1=mode: 2=storeh,
 *          4:buf_..=H|n> without_sym+idx ... (called by storeh2)
 *          8:buf_..=H|n> full
 * ToDo: always return nhn (by pointer arg?) do m1=0,1 in one step! m1==1 obsolete
 *           i + nhn in buffer[]?
 * sample: 6sites
 *   |i>=|sym_ududud>=(ududud+dududu)/q2                    - different norm2
 *   |i>=|sym_ududud>=(ududud+dududu+ududud+dududu+...)/q2/6  # not q12!
 * norm2: 1*2 
 * ToDo: return <nHn> so that nhv(m1=0);nhv(m1=1) can be replaced by nhv(m1=0) 
 * ToDo: hamilton_nhv(ibuffer[], v0, hbuf[], mode)
 * ToDo: put v0,i into hbuf (reduce arguments)
 * ToDo: split nhv to hbuf=H*|n> (Helements) and v0*hbuf
 * ---------------------------------------------------------------- */
cplx hamilton_nhv(ULong i,tvec *v0,thbuf *hbuf,int m1){
    tbase ib1, ib2;     /* target and workconfig */
    int ip1,ip2,ii,i1,i2,ia,ib; /* worksites, workindizes */
    static struct sbase abi[B_NUM],abj[B_NUM];	/* static makes pg faster, but MP is faulty ??? */
    struct sbase *bi,*bj;
    cplx sum, r1; double rp; double sun; /* sun=diagonal-summe, onlyZ? */
#if CM(0,1,1)
    int j,is;
#endif
    hbuf->i=i;                  /* index of configuration */
    bi=&abi[hbuf->block];	/* bi_array ToDo: put into hbuf! */
    bj=&abj[hbuf->block];       /* bj_array  ... */
    hbuf->n=0; /* necessary? */
    hbuf->nhn=0; /* initialize diagonal sum */
    sum=sun=0.0;
    bi->o=0;bi->skfg=ib1=getl1(i);	/* bi.skfg ?? */
#ifdef SBase
    if(!(m1&4)){
      if(base2ok) bi->norm2=(ATnorm2)norm2[i];	/* faster */
      else b_smallest(ib1,bi); /* norm2 needed (waste of cpu-power) */
    }
#endif    
/* ??? should we use symmetry at this point for speed up ??? i-j => pi-pj 
 * with smallest fitting  resulting configuration? */
    for(i1=0;i1<nw;i1++){
      ia=iw[i1][0];ip1=geti(ib1,ia);
      ib=iw[i1][1];ip2=geti(ib1,ib);
      rp=para[ww.wj[i1]];  /* exchange parameter J */
#if defined(CONFIG_S1SYM) && defined(SBase) && 1 /* N=8 s=5/2 7*faster */
      /* for composed spins take only lowest up(down) (ex: s=5,m=1: uuuudd)
       * and correct by a factor num_up(down) to speed up of (2s)^2/4
       *  ToDo: emulate by S(+/-,idx_composed)
       *  S^+|j,m>=((j-m)*(j+m+1))^(1/2)|j,m+1>
       *  S^-|j,m>=((j+m)*(j-m+1))^(1/2)|j,m-1>
       * Why C does not support break(2) to leave 2 loops?
       * subspins of composed spins must be ordered: uuu...ddd
       * ToDo: test mixed spin-lengths
       */
      if (sym.num_lm!=nn && rp && ip1!=ip2) { /* ud - du flip? */
       int nm[4],i,node;
       if (sym.ls[ia]>1 && sym.ls[ib]>1 && sym.li[ia]==sym.li[ib]) rp=0;
       for (node=0;node<2 && rp;node++){  ii=iw[i1][node];
         if (sym.ls[ii]>1) {  /* composed spin detected */
          if (sym.li[ii]!=0 && sym.li[ii]!=sym.ls[ii]-1) rp=0;
          else { /* member 0 or s-1 */
            nm[0]=nm[1]=nm[2]=nm[3]=0; /* later add 3. - .3 flip */
            for (i=0;i<nn;i++) if (sym.lm[i]==sym.lm[ii])
              for (;i<nn;i=sym.ln[i]) nm[geti(ib1,i)]++;
            if (sym.li[ii]==0)            rp*=nm[2];  /* S^+|....d> */
            if (sym.li[ii]==sym.ls[ii]-1) rp*=nm[1];  /* S^-|u....> */
          }
         }
       }
      }
#endif
      ii=ip1^ip2;
#if   CM(1,1,0)		/* SiSj+ADham1*ninj  shift -3/4,1/4 to -1,0 etc. */ 
# if   IFz		/* +ninj/4 */
#  if   Ham1
      CM({},if(ip2 && ip1),{})sun+=(.25*h_zpara+Add34)*para[ww.wj[i1]];
#  endif
# endif
      if(ii==3){
# if     IFz
        sun-=.5*h_zpara*para[ww.wj[i1]];		/* SiSj-ninj/4 */          
# endif
        if(rp!=0){ /* nondiagonal terms (sym: partly diagonal) */ 
          r1=h_xypara*.5*rp;
          /* signum of imag depends on whether ud or du */
          IFww( r1*=C(ww.co[i1],ww.si[i1]*((ip2==1)?-1:1)); )
          sum+=nhm(Flip(ib1,ia,ib),r1,v0,hbuf,m1,bi,bj);
        }
      }
# ifdef	DEBUG	
      if(err_fatal){ E0("nhv SxSx");printf(" nw=%d i=%d j=%d",i1,ia,ib); }
# endif
#endif  /* CM(1,1,0) */
#ifdef AddSS	/* only ok for JJ-model !??? */	
      /* add AddSS(SS-ZZ)=sum_(i,j).5(SipSjm+SimSjp) to Ham */
      for(ia=0;ia<nn;ia++){    ip1=geti(ib1,ia);if(ip1==1 || ip1==2)sun+=.5*AddSS;
       for(ib=ia+1;ib<nn;ib++){ ip2=geti(ib1,ib);
        if((ip1^ip2)==3) sum+=nhm(Flip(ib1,ia,ib),AddSS,v0,hbuf,m1,bi,bj);
      } }
#endif
#if   CM(0,1,1)		/* t_{ij} cp_i c_j     t=t_{ij} t^*=t_{ji} */
      if( CM( ii , ii>0 && ii<3 , ii ) ) {
        /* valid: .u  ,only tU: ud u3 ToDo: faster with tU only ii>0 ??? */
        is=parity(ib1 & p_mask[ia][ib]); /* fermionic signum without sites */
        for(j=0;j<2;j++)if(ii & (j+1)){ /* up or down */
          r1=is*para[ww.wt[i1]];        /* signum*t_{ij} */
          if( (j==0) ? ip1&2 : ip2&1 ) r1=-r1; /* fermionic sign correction */
          IFww( r1*=C(ww.co[i1],ww.si[i1]*((ip2 & (j+1))?-1:1)); )
          sum+=nhm(tbase_xor(tbase_xor(ib1,ia,j),ib,j),r1,v0,hbuf,m1,bi,bj);
        }}
#endif
    }
#if CM(0,0,1)
#if Nv             /* four-fermion-term, inter site repulsion+exchange */
      for(i1=0;i1<Nw;i1++){          /* wv: uu,ud,du,dd,u3,d3,3u,3d,33 */
        ia=iw[i1][0];ip1=geti(ib1,ia);
        ib=iw[i1][1];ip2=geti(ib1,ib);
#if Nv & 4    /* code activated if Nv is 4 for performance reasons */
        /* hole-hole repulsion, hole = empty site = (1-niu*nid) */
        /* this Hamiltonian is used by Fatiha Ouchni, Jul2004 */
        if (ip1==0 && ip2==0) sun+=para[ww.wh[i1]];
#endif
#if Ham3
#error "Code not verified. Is the sign correct?"
        if(ip1*ip2==0)if((ip1^ip2)==3) /* .3,3. -JH Oles */
          sum+=nhm(Flip(ib1,ia,ib),-para[ww.wj[i1]],v0,hbuf,m1,bi,bj);
          /* ensures symmetry */
#endif  
        /* ToDo: more general would be a 4x4 matrix ww.repulsion with
         *       sun+=para[ww.wv[i1]]*ww.repulsion[ip1][ip2]; (less if's)
         * transform ip1,ip2 to symmetric quantum numbers
         *           nij_sum=ni+nj-2=-2..2, nij_diff=ni-nj  z=nu-nd=-2..2 */
        if((ip1>0)&&(ip2>0)){
          if(ip1&1)if(ip2&1)sun+=para[ww.wv[i1]]+para[ww.wj[i1]];/* uu  U+JH */
          if(ip1&2)if(ip2&2)sun+=para[ww.wv[i1]]+para[ww.wj[i1]];/* dd       */
          if(ip1&1)if(ip2&2)sun+=para[ww.wv[i1]];		/* ud   U    */
          if(ip1&2)if(ip2&1)sun+=para[ww.wv[i1]];		/* du        */
          if((ip1^ip2)==3)					/* ud,du  JH */
           sum+=nhm(Flip(ib1,ia,ib),para[ww.wj[i1]],v0,hbuf,m1,bi,bj);}
      }
#endif
      for(i1=0;i1<nn;i1++){ ip1=geti(ib1,i1);
#if Ne
        if(ip1&1)sun+=para[ww.we[i1]]; /* E nu */
        if(ip1&2)sun+=para[ww.we[i1]]; /* E nd */
#endif
#if Ham2
        sun+=((ip1%3)?-.25:.25)*para[ww.wu[i1]];	/* U(nu-.5)(nd-.5) */
#else
        if(ip1==3)sun+=para[ww.wu[i1]];		/* U nu nd */
#endif
      }
#endif
#ifdef HFIELD
      for(i1=0;i1<nn;i1++){ ip1=geti(ib1,i1);
        sun-=((ip1&1)-(ip1>>1&1))*para[ww.wf[i1]]/2;
      }
#endif

#define S_DEBUG(a) a
#ifdef SSANISO
#ifndef CONFIG_S1SYM
# error "defining SSANISO without CONFIG_S1SYM makes no sence"
#endif
     { /* this code was introduced by Reimar Schmidt, Jan 2004 */
       int k,i2; double oZi; static unsigned int dbg=0;
       /* oZi - eigenvalue of S^z_i of a composed spin
        *  Di - ww.wd index to float parameter (defined in daten.def)
        *  code revised by Joerg v2.20 */
       /* num_lm is N for a s=1 chain of length N build by NN=2*N spins s=1/2 */
       for(k=0;k<sym.num_lm;k++){  /* k = index of a composed spin-s object */
         for(oZi=0.0,i2=NN,i1=0;i1<nn;i1++)  /* sum S^z(i) over a composed spin */
           if(sym.lm[i1]==k) { /* check if spin i is member of composed spin */
             oZi+=(3-2*geti(ib1,i1))/2.0;
             if (i1<i2) i2=i1; /* get index of 1st member of composed spin */
           }
         sun+=oZi*oZi*para[ww.wd[i2]]; /* add to the diagonal element */
         S_DEBUG( if (dbg++<10) printf("\n dbgD k=%2d oZi=%4.1f d[i]=%.2f %s", k, oZi, para[ww.wd[i2]],ckfg(ib1));)
       }
     }
#endif
#if CM(1,0,0)
     if (nq) {  /* four-site ring term, see op_rot4() too */
       for (i1=0;i1<nq;i1++) {
         ib2 = ib1;
         for (i2=0; i2<4; i2++) {
           ip1 = geti(ib1, iq[i1][i2]);             /* take site i */
           ib2 = puti(ib2, iq[i1][(i2+1)%4], ip1);  /* put to site i+1 */
         }
         /* rotation */
         sum+=nhm(ib2,para[ww.wq[i1]],v0,hbuf,m1,bi,bj);

         ib2 = ib1;
         for (i2=0; i2<4; i2++) {
           ip1 = geti(ib1, iq[i1][i2]);             /* take site i */
           ib2 = puti(ib2, iq[i1][(i2+3)%4], ip1);  /* put to site i-1 */
         }
         /* inverse rotation */
         sum+=nhm(ib2,para[ww.wq[i1]],v0,hbuf,m1,bi,bj);
       }
     }
#endif

#ifdef EDIAG
      sun+=EDIAG;  /* add 1000.0 if energy is -1000.00365 for better results */
#endif
      /* store diagonal value <nHn> */
      sum+=nhm(ib1,sun,v0,hbuf,m1,bi,bj);
      if (m1  & 2) nhmline(hbuf); /* write to H-file */
      if (vvv & 2) chkhnl();      /* statistics */ 
      return(sum);                /* return nHv or nH1(?) */
}

/* void-function for pthreads */
void hamilton_nhv_block( void *ptr ){
      ULong i; cplx r; thbuf *hbuf=(thbuf *)ptr;
      int block=hbuf->block;
      for(i=b_sn1[block];i<b_len[block];i++){
        r=hamilton_nhv(b_ofs[block]+i,hbuf->v0,hbuf,0);
        hbuf->v1->v[block][i]+=M_d2f(r); /* rounding error ??? */
        hbuf->r+=Conj(M_f2d(hbuf->v0->v[block][i]))*r;
      }
}

/* call h_ropen first! ToDo: inline it -> moved to spins.c (inlined)
 * if !STORE_XandY xx is only correct for the first block ?! 
 * ToDo: async version: return the next block (not input block)
 * h_get was put into geth_block (v2.26)
 * static inline .. is not inlined on OSF1-CXX if to complex */ 

/* void-function for pthreads, read a complete H-block and do v1=H*v0
 * for better speed, this part should be read in ca. 1000 values from vy, 
 * than from vx0, than store to vx1 to use the CPU cache optimal
 * ToDo: open/close h_files before calling this
 */
void hamilton_geth_block( void *ptr ){ /* thbuf is in prinzip not needed! */
    ULong i,in,by,ii; thbuf *hbuf=(thbuf *)ptr;
    int block=hbuf->block;
    ULong xx,xy,yy; mcplx *v0x,*v1x; cplx r,sum_ry;
    /* read one HBLine=B_NUM*HBlocks */
    /* ToDo: test 4cpu_read_blocks: cpu0=0,1,2,3 cpu1=1,2,3,0 cpu2=2,3,0,1 ... */
    v0x=hbuf->v0->v[block];
    v1x=hbuf->v1->v[block];
    xx=b_ofs[block]; if (xx>=n1) ERR(9420);
    in=b_snz[block]; /* number of elements in HBlock */
    sum_ry=0;
    ii = b_hbl[block]; /* used by h_wclose, set by h_ropen */
    /* ToDo: use pointer to b_hbuf[block] */
    for (i=0l; i<in; i++,ii++) {  /* ToDo: unroll loop by CC-option */
      /* this is the innermost loop, NFLOP=5*hnz*NumIteration */
      /* h_get(); inserted here, because inline dont work always */
      if( ii>=HBLen ){ /* fill empty read-buffer */
        h_read(block); ii=0; /* read next block from matrix H */
#ifndef STORE_XandY
        xx= (ULong)b_hbuf[block].xx;  /* not sure, that this is always ok */
#endif
      }
      xy=   (ULong)b_hbuf[block].xy[ ii ];
#ifdef STORE_XandY
      xx=   (ULong)b_hbuf[block].xx[ ii ];
#endif
#if HRMAX>0
      r = hr[block][ b_hbuf[block].r[ ii ] ];
#else
      r =     M_f2d( b_hbuf[block].r[ ii ] );
#endif
      /* end of h_get */
      yy = xy & ~XY_FLAG;
      #ifdef DEBUG
        if (yy<0 || yy>=n1 || xx>=n1) ERR(9420);
      #endif
      /* ToDo: try to group indizes to same memory bock */
      by = b_getnum(yy);
      #ifdef DEBUG
        if (by>=B_NUM || yy-b_ofs[by]>=b_len[by] ||  yy<b_ofs[by]) ERR(9421);
      #endif
      sum_ry  += r * (*(hbuf->v0->v[by] + yy - b_ofs[by])); /* v0y + yy */
      /* verify: random memory access, 98%CPU v2.17, cache misses? */ 
      /* ToDo: cache sum_ry[HBLen] = Hblock*v0y, than do the multiplication */
      if (xy & XY_FLAG){ /* next line of sparse matrix starts */
        hbuf->r += Conj(M_f2d(*v0x))*sum_ry;
        (*v1x)  +=      M_d2f(       sum_ry);  /* r/w memory, cache miss!? */
        // printf(" sum= %e",sum_ry);
        sum_ry = 0; xx++; 
        v0x++; v1x++;
      }
    }
    b_hbl[block]=ii; /* not needed */
}

/* auch gleich r1=<v0|H*v0> zurueckliefern ??? must be real!
   <re-im Hre+Him re+im> = <re|Hre re>+<re Him im>+<im Hre im>+<im Him re>
   using long double ???
 */
cplx hamilton( tvec *v0, tvec *v1){         /* v1=H*v0+v1 */
  ULong i; int block,bnum=B_NUM;
  thbuf * (hbuf)[B_NUM]; /* one buffer per compute thread, better alloc locally */
  cplx r2;
  STKa("hamilton",(unsigned long *)&i);r2=0.0;
{
  for(block=0;block<B_NUM;block++) /* X*open,X*Close, not X*(open,close) */
    if (b_len[block]) h_ropen(block); /* open I/O streams + buffer v2.26 */
  for(block=0;block<bnum;block++){ if ( b_len[block]==0 ) continue;
    hbuf[block]=alloc_hbuf(); /* better alloc local in thread? */
    hbuf[block]->block=block; 
    hbuf[block]->v0=v0;
    hbuf[block]->v1=v1; hbuf[block]->r=0.0;
#ifdef CONFIG_PTHREAD
    parallel_start( block, hamilton_geth_block, hbuf[block] );
#else
    hamilton_geth_block( hbuf[block] );
#endif
  }
  for(block=0;block<bnum;block++){ if ( b_len[block]==0 ) continue;
#ifdef CONFIG_PTHREAD
    parallel_wait(block);
#endif
    h_rclose(block); /* v2.26 close buffer chain and finaly the file */
    r2+=hbuf[block]->r;
    free_hbuf(hbuf[block]);
  }
}
  /* prepared for pthreads / parallel processing */
#ifdef CONFIG_PTHREAD
  for(block=0;block<bnum;block++){
    /* big local vars (sbase), relatively bad for parallelisation */
    if(b_sn1[block]<b_len[block]){ /* ??? */
      hbuf[block]=alloc_hbuf(); /* better alloc locally in thread? */
      hbuf[block]->block=block; hbuf[block]->v0=v0; 
      hbuf[block]->v1=v1; hbuf[block]->r=0.0;
      parallel_start( block, hamilton_nhv_block, hbuf[block] ); /* better arg2 = function instead of idx */
    }
  }
  for(block=0;block<bnum;block++){
    if(b_sn1[block]<b_len[block]){ /* ??? */
      parallel_wait(block);
      r2+=hbuf[block]->r;
      free_hbuf(hbuf[block]);
    }
  }
#else
  for(block=0;block<bnum;block++){
    /* big local vars (sbase), relatively bad for parallelisation */
    if(b_sn1[block]<b_len[block]){ /* ??? */
      hbuf[block]=alloc_hbuf();
      hbuf[block]->block=block; hbuf[block]->v0=v0; 
      hbuf[block]->v1=v1; hbuf[block]->r=0.0;       
      hamilton_nhv_block( hbuf[block] );
      r2+=hbuf[block]->r;
      free_hbuf(hbuf[block]);
    }
  }
#endif
  STKe();return r2;
}

/* void-function for pthreads */
void storeh_block( void *ptr ){
      ULong i, iout, l1, l2; cplx r;
      thbuf *hbuf=(thbuf *)ptr;
      int block=hbuf->block, i2;
      l1=itime();
      i2=19;       /* we dont need that info for small systems */
      iout=1<<i2;  /* dont flood output, output it sparingly */
      for(i=0;i<b_len[block];i++){
        /* next line is called very often and reduces speed (how much?),
         * but at time of writing it was not of importance,
         * its only to estimate CPU time and can be removed */
        if ((!block) && i==iout) { /* reduce output to 1 thread */
          l2=itime();
          printf("\n storeh_block i=2^%d %3lu%% hnz/i= %6.2f t= %6lus SHt=%s",
                 i2, i*100/b_len[block], ((double)b_hnz[0])/i, l2-l1,
                 sclock((l2-l1)*(b_len[block]*100/i)/100));
          i2++; iout*=2;
        }
        /* ToDo: replace by get(+store) next H-elements, not only one */
        /* ToDo: return number of lines filled into the buffer? */
        r=hamilton_nhv(b_ofs[block]+i,vnul,hbuf,2);
        hbuf->r+=r; /* not needed */
      }
      if(err_fatal){	/* check 2 summs upper==lower-dreiecksmatrix??? */
        E3("err_fatal: blk=%d i=%lu h_nz=%lu",block,b_ofs[block]+i,b_hnz[block]);
        /* break; */
      }
}

void storeh(){
  ULong i,i1,i2/* ,l=0l,m=0l */;cplx tr1,r1=0.0; int block;
  thbuf * (hbuf)[B_NUM]; double h_nn, h_nz;
  STKa("storeh",(unsigned long *)&i);if(vvv&1)printf("\n storeh");
  /* --- Anzahl minimal benoetigter Bytes fuer thxy.xy bestimmen Dez98 --- */
  chkhxyini();	/* Oct99 */
  ini_thxy(n1);
  printf(" sizeof(HR_TYPE)=%d\n",(int)sizeof(HR_TYPE));
  i1=itime();i2=iclock();
  if( checkpoint<3 ) { tr1=0.0;
    for(block=0;block<B_NUM;block++) /* X*open,X*Close, not X*(open,close) */ 
      h_wopen(block); /* open I/O streams + ini buffer */
    for(block=0;block<B_NUM;block++){
      /* big local vars (sbase), relatively bad for parallelisation */
      hbuf[block]=alloc_hbuf(); /* ToDo: alloc data area within the thread */
      hbuf[block]->block=block; /* pthread's number */
      hbuf[block]->v1=hbuf[block]->v0=vnul;
      hbuf[block]->r=0.0; /* only a check sum? */
#ifdef CONFIG_PTHREAD
      parallel_start( block, storeh_block, hbuf[block] ); /* start compute threads */
#else
      storeh_block( hbuf[block] );  /* single task */
#endif
    }
    for(block=0;block<B_NUM;block++){
#ifdef CONFIG_PTHREAD
      parallel_wait(block); /* stop compute threads and let them wait */
#endif
      h_wclose(block);  /* flush H-buffers to disk */
      tr1+=hbuf[block]->r;
      free_hbuf(hbuf[block]);
    }
    r1+=tr1; /* not needed, only for debugging if sumHelements has not changed */
    i2=iclock()-i2;i1=itime()-i1;
    /* ToDo: output time in a form where it can be removed for comparisions
     * example: diff <(sed 's/\([0-9]{2}\)/#1/g' out1) <(sed '' out2)
     */
    if (vvv) printf("\n SH=%.8e SH.t=%s clocks=%lu",
                    fabs(r1), sclock((long)i1), i2);
    close_thxy(1);
    printf(" checkpoint=%d",++checkpoint);
  } else restore_thxy(1);
  /* storeh complete, print statistics */
  if( h_error ){  /* error during write is fatal, ignore all things written */
    E0("disk full? written data will not be used"); h_error=0;
    for(h_nn=0,block=0;block<B_NUM;block++){ b_snz[block]=0; }
    for(h_nn=0,block=0;block<B_NUM;block++){ b_sn1[block]=0; }
  }
  for(h_nz=0,block=0;block<B_NUM;block++) h_nz+=(double)b_hnz[block];
  for(h_nn=0,block=0;block<B_NUM;block++) h_nn+=(double)b_snz[block];
#if  defined(DEBUG)
  for(block=0;block<B_NUM;block++){
    printf("\n sn1 = %9lu snz =",b_sn1[block]);
    for(i=0;i<B_NUM;i++) printf(" %9lu",b_snz[block*B_NUM+i]);
  }
#endif
  if (vvv) printf("\n h_nz = num of matrix elements, h_nn = stored elements");
  printf("\n h_nz %.3e h_nn %.3e h_nn/h_nz %3.0f%% hxy_size %d/%d=%d (+%d)",
             h_nz,     h_nn,((h_nz)?(100*h_nn)/h_nz:0.0),
             (int)Hsize,HBLen,(int)Hsize/HBLen,(int)Hsize%HBLen);
  if (h_nn<h_nz) {
    printf("\nWarning: not all elements stored!!!");
    printf("\nWarning: %.2e B disk space needed for best speed.", 1.*Hsize*h_nz/HBLen);
  }
  if(vvv&2)outhxy(); STKe();
  return;
}

/* --------------------- Jan13 2000 -------------------------------
 * new way for storing l1 and H, is it faster than the old way?
 * it should generate the symmetric states itself by
 * - starting with symmetric config
 * - using iterativ H, and symconfig and sort to generate new sym-configs
 * - until H generates no new configs (m1=0 run1 for n1, m1=1 run2 for sh)  
 */
void storeh2(ULong m1){
  ULong t1,t2,i1,i2,i3,i4,i5,i6,i0; int j1,j2,j3,block;
  struct sbase b,bi; tbase ib; double h_nz, h_nn;
  static thbuf hbuf;
  static ATnorm2 buf_n2[NZXMAX];	/* buffer for norm2 */
  STKa("storeh2",(unsigned long *)&i1);
  if(vvv&1)printf(" storeh2\n");b.o=0;
  chkhxyini();	/* Oct99 */
  /* das speichern des letzten hnz der Zeile macht probleme! da sich n1 aendert! */
  ini_thxy(n1); /*  */
  t1=itime();t2=iclock();
  i1=0;		/* pointer to last unchecked state */
  i2=1;		/* pointer to next free entry */ 
  if(m1==0){		/* starting state == Neelstate (lowest ising erg) */
    ib=TBASE0;i0=0l;
    for(j1=0;j1<2*nd;j1+=2) ib=puti(ib,j1%nn+j1/nn,2); /* ib=Neel */
    /* MC steps to lower energy if possible, only JJ-model, ToDo */
    { 
      int *k1, *k2;   /* pair korrelations == ising erg */
      tbase ib2, ib3=ib;      /* test state */
      int z1, z2, j3;
      for (j3=2;j3>0;j3--) { /* down counter */
        k1=get_dkorr(ib ,3, NULL);
        for (j1=0   ;j1<nn-1;j1++)
        for (j2=j1+1;j2<nn  ;j2++)
          if(j1!=j2 && (z1=geti(ib,j1))!=(z2=geti(ib,j2))) {
          /* now j1 and j2 are different neighbours */
          ib2=puti(puti(ib,j2,z1),j1,z2); /* j1 <=> j2 */
          k2=get_dkorr(ib2, 1, NULL);
          /* prefer more movable pairs, ToDo: check all korrs */
          if (k1[1*5+1]< k2[1*5+1] ||
             (k1[1*5+1]==k2[1*5+1] && k1[2*5+1]<k2[2*5+1])) {
                 j3=2; ib=ib2; free(k1); k1=k2; j1=j2=nn;
                 b_getbase(ib,&b); if (b.sign!=0) ib3=ib; /* store sign!=0 */
              }
          else free(k2);
        }
        free(k1);
      }
      ib=ib3;
    }
    printf("\n start konfig= %s",ckfg(ib));
    b_getbase(ib,&b);ib=b.skfg;
    printf("\n         skfg= %s  sign=%+g",ckfg(b.skfg), D(b.sign));
    if( b.sign==0
#ifdef CONFIG_ANSATZ
     || 0==ansatz_test(hbuf.el[j1].kj)		/* fuer Variationsansatz */
#endif
    ) {
    printf("\n bad start konfig (sign==0 || proj==0), try another");
    for(i0=0;i0<10000;i0++){ ib=ll1(i0); b_getbase(ib,&b); ib=b.skfg;
      if( b.sign!=0
#ifdef CONFIG_ANSATZ
      && 0!=ansatz_test(hbuf.el[j1].kj)		/* fuer Variationsansatz */
#endif
      )break; }
    }
    putl1(0,ib,l1);	/* first state = starting state */
    if (norm2){ norm2[0]=(ATnorm2)b.norm2;
      if ((ATnorm2)norm2[0]!=b.norm2){
        ERR(600); 
        norm2=(ATnorm2 *) myfree((void *) norm2, &m_n2);
      }
    }
    if(l2b)l2b[0]=0;	/* sorting-idx */
    printf("\n start konfig= %s",ckfg(ib));
  } else i2=m1;   /* start with picked state */
  h_wopen(0);
  for (;;) {
    hbuf.n=0;
    hamilton_nhv(i1,vnul,&hbuf,4); 	/* store H-line only in buf_ */
    if (err_fatal) { E1(" err_fatal: i1=%lu",i1); break;}
    if (i1<100 && vvv&64) { printf("\n H|i1> = H|%s> i1=%5lu i2=%5lu",
                       ckfg(getl1(i1)),i1,i2);
                       get_dkorr(getl1(i1),2,NULL);
      }
    if (norm2) bi.norm2=norm2[i1]; else { 
      b_getbase(getl1(i1),&bi);	/* need for bi.norm2 */
      if(phase_eq(bi.sign,0)) E0(" should not happen!");
    }

    for(j1=0;j1<hbuf.n;j1++)if(hbuf.el[j1].r!=0)	/* test all H|kfg> */
#ifdef CONFIG_ANSATZ
    if(ansatz_test(hbuf.el[j1].kj))		/* for variational ansatz */
#endif
    {					/* every kfg with <kfg|H|i1>!=0 */
      b_getbase(hbuf.el[j1].kj,&b);		/* dont forget is==0!!! ??? */
      // b_smallest(hbuf.el[j1].kj,&b);		/* dont forget is==0!!! ??? */
      /* representator, better use w2w ??? */
      hbuf.el[j1].r*=b.sign; hbuf.el[j1].kj=b.skfg;
      buf_n2[j1]=(ATnorm2)b.norm2;
      for(j2=j1+1;j2<hbuf.n;j2++) if(hbuf.el[j2].r!=0)
      for(j3=  1;j3<b.num;j3++) if(b.is[j3]!=0) if(b.ib[j3]==hbuf.el[j2].kj){
        hbuf.el[j1].r+=b.is[j3]*b.sign*hbuf.el[j2].r;hbuf.el[j2].r=0;	/* same kfg */
        hbuf.n--;hbuf.el[j2].r=hbuf.el[hbuf.n].r;hbuf.el[j2].kj=hbuf.el[hbuf.n].kj; /* compress */
        j2--;break;
      }
      if(b.norm2!=0 && bi.norm2!=b.norm2)
         hbuf.el[j1].r*=sqrt((double)bi.norm2/(double)b.norm2);
    }		/* debugging friendly src-code ??? */

/* parallel ???????, braucht immense Zeit */
    i4=i2;
    for(j1=0;j1<hbuf.n;j1++)if(hbuf.el[j1].r!=0){	/* allready stored? */
      if(hbuf.el[j1].kj==getl1(i1)){ hbuf.el[j1].j=i1;continue; }
      i3=i2;
      if(l2b)
      {	/* suche im sortierten hilfsindex - schneller?! */
        for(i6=1;i6<=i4;i6<<=1);	/* i4 - hintere bits */
        for(i5=0;i6;i6>>=1){		/* interval-Halbierung */
          if (i5+i6>=i4) continue;      /* i+i/2 > max */
          if (getl1(l2b[i5+i6])<=hbuf.el[j1].kj) i5+=i6;
        }
        if(getl1(l2b[i5])==hbuf.el[j1].kj){
              hbuf.el[j1].j=l2b[i5];continue; } /* found, min_j? */
        if(i4>=n1){ hbuf.el[j1].r=0;continue; } /* 0-Projection, count? */
        /* insert new element, max_j? -> max(maxj-minj) v-size? */
        for(i6=i4;i6>i5;i6--)l2b[i6]=l2b[i6-1];
        if(i5==0 && hbuf.el[j1].kj<=getl1(l2b[i5])) l2b[0]=i4; else
        l2b[i5+1]=i4;
      } else {	/* sequential searching is very slow! */
        for(i3=0;i3<i2;i3++)if(hbuf.el[j1].kj==getl1(i3))break;
        if(i3<i2){ hbuf.el[j1].j=i3;continue; }	/* already stored */
      }
      if(i4>=n1){ hbuf.el[j1].r=0;continue; }
      putl1(i4,hbuf.el[j1].kj,l1); hbuf.el[j1].j=i4;
      if(norm2){ norm2[i4]=buf_n2[j1];
        if(norm2[i4]!=buf_n2[j1]){
          ERR(600);norm2=(ATnorm2 *)myfree((void *) norm2, &m_n2);
        }
      }
      i4++;
      if(i4==n1) E0("n1-ovl");		/* nur 1mal Fehlermeldung */
    }
    if(i4==1 && hbuf.n==0){ ERR(500);break; }
    hbuf.i=i1;
    nhmline(&hbuf);	/* write Hamiltonian!!! run2 n1=correct */
    i2=i4;i1++;if(i1>=i2)break;

  }
  h_wclose(0); 
  t2=iclock()-t2;t1=itime()-t1; close_thxy(1); n1=i1;
  if(vvv)printf(" SH2 nk=%lu SH.t=%s=%lu n1=%lu\n",i2, sclock((long)t1),t2,i1);
  if(vvv&2)outhxy();
  /* hnz = number of stored elements, snz = number of stored lines */
  for(h_nz=0,block=0;block<B_NUM;block++) h_nz+=(double)b_hnz[block];
  for(h_nn=0,block=0;block<B_NUM;block++) h_nn+=(double)b_snz[block];
  for(block=0;block<B_NUM;block++) if (b_len[block]>i1) b_len[block]=i1;
  if (vvv) printf("\n h_nz = num of matrix elements, h_nn = stored elements");
  printf("\n h_nz %.3e h_nn %.3e %3.0f%% hxy %d",
             h_nz,     h_nn,(h_nn*100.0)/h_nz,(int)Hsize/HBLen);
  if(h_nn<h_nz)
  printf("\nWarning: %.2e B for maximum speed needed.", 1.*Hsize*h_nz/HBLen);
  STKe();return;
}

int outbasis(FILE *f){
    ULong i;
#ifdef SBase    
    static struct sbase b; int i1,i2,i3,i4,i6; b.o=0;
#endif
    if(vvv&64/* ??? */){ fprintf(f,"\n vvv&64: B=[");
      for(i=0l;i<n1;i++){    if(i!= 0l)fprintf(f,",");
        if(i<x_max)fprintf(f,"\n%4lu %s ",(ULong)i,ckfg(getl1(i)));
              else{fprintf(f," ... ");break;}
#ifdef SBase
        b_getbase(getl1(i),&b);fprintf(f,"*q(%4g)=(",(double)b.norm2);
        /* this is ising like energy for all diff. korrelations */
        for(i4=0,i1=1;i1<sym.num_dkorr;i1++){ i6=0;
           for(i2=   0;i2<nn;i2++)
           for(i3=i2+1;i3<nn;i3++)
           if(sym.korr[i2][i3]==i1) {
            if(geti(b.skfg,i2)==1 && geti(b.skfg,i3)==1); else
            if(geti(b.skfg,i2)==2 && geti(b.skfg,i3)==2); else
            i6++; /* ud - symmetric */
           }
           i4+=i6;
           printf(" %2d",i6); /* printf("+%2d+%2d",i4,i6); */
        }
        fprintf(f," sum= %d)  ",i4);
#endif        
      } fprintf(f,"]\n");
    }
    return(0);}

int zi(tbase kfg,int i){   /* Siz -> -1,0,1 */
#if CM(1,0,0)
  return 1-2*(int)(1&(kfg>>i));}
#else
  int i1=geti(kfg,i); return( (i1==2) ? -1 : (i1==1) ? 1 : 0);}
#endif

int zizj(tbase kfg,int i,int j){   /* Siz*Sjz -> -1,0,1 */
#if CM(1,0,0)
  return 1-2*(int)(1&((kfg>>i)^(kfg>>j)));}
#else
  int i1=geti(kfg,i)*geti(kfg,j); return((i1==2)?-1:(i1==4 || i1==1)?1:0);}
#endif

double sq( double x){ return x*x; }

/* calculate the geometrical distance^2 between site i1 and i2 */
double distance( int i1, int i2){
  double d1,d2;
  int i,j,k;
  d1=sq(pos[i1][0]-pos[i2][0])
    +sq(pos[i1][1]-pos[i2][1])
    +sq(pos[i1][2]-pos[i2][2]);
  for(i=-1; i<2; i++)
  for(j=-1; j<2; j++)
  for(k=-1; k<2; k++) { /* brute force, test surrounding boxes */
    d2=sq(pos[i1][0]-pos[i2][0]+i*edg[0][0]+j*edg[1][0]+k*edg[2][0])
      +sq(pos[i1][1]-pos[i2][1]+i*edg[0][1]+j*edg[1][1]+k*edg[2][1])
      +sq(pos[i1][2]-pos[i2][2]+i*edg[0][2]+j*edg[1][2]+k*edg[2][2]);
    if (d2<d1) d1=d2;
  }
  return d1;
}
/*
 ***********************************************************************
 ***********************************************************************
 */
/*  ************ check of the eigenvector and eigenvalue ************ */
/* Inp: v0  Out: v1  H*v0, rh=<v0*H*v0>, rq=norm(H*v0-h*v0) 
   Ausgaben werden mit XX= beschrieben, diese koennen mit awk bearbeitet
   werden  */
int chk3(tvec *v0,tvec *v1,int iv){
    int i1,i2,i3,j1,j2,j3,deg; long l1; cplx r;double d1,d2;
    static double sisj[NN][NN],zizj[NN][NN];
#if defined(N1) && defined(N2) && CM(1,0,0)
#if N1>1 && SBase==0
    cplx r1,r2;
#endif
#endif    
    deg=0; /* degenerate ? */

    for(i1=0;i1<nn;i1++)for(i2=0;i2<nn;i2++)zizj[i1][i2]=sisj[i1][i2]=0.0;

#if !defined(Dimer)	/* better: only for generators <T>!!! Nov98 */
#ifndef SBase
    if(vvv&1)printf(" T=");for(i1=0;i1<sym.numsym;i1++)if(sym.g[i1]){
     printf(" %4.1f",D(r=wop_k(v0,v0,i1)));if(fabs(r)<0.999)deg=i1+1;}/* Px */
    if(nu==nd)printf(" ud= %4.1f",D(wop_ud(v0,v0)));	/* ud */
#endif

/* write a general diff_pair_korr(fkt{-NR},array[][],v0)
 *  and call with sisj,zizj or fkt=1,2,3... */
    l1=itime(); /* measure zizj-time */
#if Korrelations
    /* 3*<ZiZj>=<SiSj> nur, wenn <SS>=0 (singlet), auch bei Entartung (?) */
    /* could be problematicaly od degenerate states! not proofed */
    for(i3=0;i3<sym.num_dkorr;i3++){
      int sites[2]; long l2=itime();
      sites[0]=i1=sym.dkorr[i3][0];
      sites[1]=i2=sym.dkorr[i3][1];
      zizj[i1][i2]=D( wop(&op_zizj,NULL,2,sites,v0,v0) ); /* ZiZj */
      for(j3=j1=0;j1<nn;j1++)for(j2=0;j2<nn;j2++)
      if(sym.korr[j1][j2]==i3){
        zizj[j1][j2]=zizj[i1][i2]; /* copy same bonds */
        j3++;              /* count num of same bonds */
      }
      printf("\n i-j %2d %2d ZiZj %9.6f",i1,i2,zizj[i1][i2]); /* kurz+knapp */
      printf("  num= %4d  r^2= %7.3f ij.t=%s", j3, distance(i1,i2),
             sclock(itime()-l2));
    }
    printf("\n %dzij.t=%s", sym.num_dkorr, sclock(itime()-l1));

    for(i3=-1,i1=0;i1<nn;i1++)
    if(sym.korr[i1][i1]>i3){ i3=sym.korr[i1][i1];
      printf("\n i= %2d ZiZj=",i1);	/* 3ZiZj using sh/awk (simpler!) */
      for(i2=0;i2<nn;i2++) printf(" %9.6f",zizj[i1][i2]);
    }
    printf("\n Warning: SiSj=3ZiZj, ZiZj only correct for EA=1, sum over Sz too!");/* Jun99 */

    for(i1=0;i1<nn;i1++)for(i2=0;i2<nn;i2++){
      sisj[i1][i2]=3*zizj[i1][i2]; }		/* 3*ZiZj isotropic */
    if(cfg_sisj&1)	/* set in daten.i */
    { 
      int sites[2]; long l2;
      l1=itime();
      if(vvv&1)printf(" t=%s",sclock(~0l));
      /* could be problematicaly on degenerate states! not proofed */
      for(i3=0;i3<sym.num_dkorr;i3++){
        l2=itime();
        sites[0]=i1=sym.dkorr[i3][0];
        sites[1]=i2=sym.dkorr[i3][1];
        sisj[i1][i2]=D( wop(&op_sisj,NULL,2,sites,v0,v0) );  /* SiSj */
        printf("\n i-j %2d %2d SiSj %9.6f",i1,i2,sisj[i1][i2]);
        for(j3=j1=0;j1<nn;j1++)for(j2=0;j2<nn;j2++)
        if(sym.korr[j1][j2]==i3){
          sisj[j1][j2]=sisj[i1][i2]; /* copy same bonds */
          j3++;              /* count num of same bonds */
        }
        d1=sisj[i1][i2]-3*zizj[i1][i2];
        printf("  Sij-3Zij= %9.6f %6.0e num= %4d ij.t=%s",
               d1, d1, j3, sclock(itime()-l2));
      }
      printf("\n %dsij.t=%s", sym.num_dkorr, sclock(itime()-l1));
      for(i3=-1,i1=0;i1<nn;i1++)
      if(sym.korr[i1][i1]>i3){ i3=sym.korr[i1][i1];
        printf("\n i= %2d SiSj=",i1);				/* SiSj */
        for(i2=0;i2<nn;i2++) printf(" %9.6f",sisj[i1][i2]); }
    }
    if(vvv&1)printf(" t=%s",sclock(~0l));
    for(i3=-1,i1=0;i1<nn;i1++) if(sym.korr[i1][i1]>i3){	/* okt98 */
      printf("\n i= %2d Zi=",i1);				/* Zi */
      i3=sym.korr[i1][i1]; 
      d1=D( wop(&op_zi,NULL,1,&i1,v0,v0) ); /* Zi */
      printf(" %9.6f Zi-(nu-nd)/(2N)= %9.6f",d1,d1-(nu-nd)/(2.*nn));
    }
    if(vvv&1)printf(" t=%s",sclock(~0l));

    for(d1=i1=0;i1<nn;i1++)for(i2=0;i2<nn;i2++)
    d1+=sisj[i1][i2]; d2=fabs(d1); d2=fabs(-1.0+sqrt(1+4*d2));    /* 2S */
    printf(  "\n SS= %5.3f 2S= %5.3f % 5.0e",d1,d2,d2-(int)(d2+.5));

    for(d1=i1=0;i1<nn;i1++)for(i2=0;i2<nn;i2++)
    d1+=fabs(zizj[i1][i2]); d1=fabs(d1/(nn*nn)); /* ZMag=1/N^2 Sum |ZiZj| */
    printf("\n ZMag= %10.8f",d1); d2=d1;

    for(d1=i1=0;i1<nn;i1++)for(i2=0;i2<nn;i2++)
    d1+=fabs(sisj[i1][i2]-zizj[i1][i2]); d1=fabs(d1/(nn*nn));
    printf(  " XYMag= %10.8f",d1);		/* XYMag=1/N^2 Sum |XYiXYj| */

    for(d1=i1=0;i1<nn;i1++)for(i2=0;i2<nn;i2++) /* SMag=1/N^2 Sum |SiSj| */
    d1+=fabs(sisj[i1][i2]); d1=fabs(d1/(nn*nn));
    printf(  " SMag= %10.8f SMag-3ZMag= %10.8f",d1,d1-3*d2);

    /* this type of magnetization is for test if SMag(E) in same order? */
    for(d1=i1=0;i1<nn;i1++)for(i2=0;i2<nn;i2++)
    d1+=zizj[i1][i2]*zizj[i1][i2]; d1=sqrt(d1/(nn*nn));
    printf("\n Z2Mag= %10.8f",d1); d2=d1; /* Z2Mag=(1/N^2 Sum ZiZj^2)^.5 */

    for(d1=i1=0;i1<nn;i1++)for(i2=0;i2<nn;i2++)
    d1+=sisj[i1][i2]*sisj[i1][i2]; d1=sqrt(d1/(nn*nn));
    printf(  " S2Mag= %10.8f ",d1);  /* S2Mag=(1/N^2 Sum SiSj^2)^.5 */

#endif /* Korrelations */

    r=wh(v0);	 printf(" E%d/N= %12.8f",iv,D(r)/nn);
    		 printf(  " E%d= %12.8f",iv,D(r));
    r=whq(v0,r); printf(" %5.0e" ,D(r));   /* (H*v-<vHv>*v)^2 */
    /* if((fabs(r)>1.e-5) && (v1!=NULL)) return deg; */ 

    if(sym.numsym<60 || (double)n1<1e6) /* takes time, change ??? */
    /* wss is slow, if we have ss from sisj we dont need it again */
    if(cfg_sisj&2) {
      l1=itime();
      printf(" 2S= %5.3f",D(wss(v0,v0)));		/* 2S */
      printf(" 2S.t=%s", sclock(itime()-l1));
    }
#if  CM(0,0,1)
    printf(" 2J= %5.3f",D(wjj(v0,v0)));			/* 2J */
#endif

#if defined(SITE_DIST)
    /* --- staggered Magnetization --- */
    for(r=i2=0;i2<nn;i2++)r+=((site_dist(0,i2)&1)?-1:1)*sisj[0][i2];
    printf(" StaggMag= %9.6f",D(r)/nn);
#endif
# ifdef Spin1chain
    stringorder2(stdout,v0);
# endif    
#else /* defined(Dimer) */
				/* SiSj */
    stringorder(stdout,v0);
    for(i1=0;i1<nn;i1++)sisj[0][i1]=3*zizj[0][i1];/* sowieso schon Dez99 */
    for(i1=0;i1<nn;i1++)sisj[2][i1]=3*zizj[2][i1];
    /* ##### C_x=Sum_(i!=j,(i,j aus X)){|<SiSj>|} ##### */
    d1=.0;							/* C_tot */
    for(i1=0;i1<nn;i1++)if(i1!=0)  d1+=fabs(sisj[0][i1]);
    for(i1=0;i1<nn;i1++)if(i1!=2)  d1+=fabs(sisj[2][i1]);
    printf(" C_tot= %8.6f",(double)d1/(2*(nn-1)));
    d1=.0;							/* C_d */
    for(i1=0;i1<nn;i1++)if(i1%4<2)if(i1!=0) d1+=fabs(sisj[0][i1]);	
    printf(  "C_d= %8.6f",(double)d1/(nn/2-1));
    d1=.0;							/* C_p */
    for(i1=0;i1<nn;i1++)if(i1%4>1)if(i1!=2) d1+=fabs(sisj[2][i1]);	
    printf(  "C_p= %8.6f",(double)d1/(nn/2-1));
    d1=.0;							/* C_pd */
    for(i1=0;i1<nn;i1++)if(i1%4<2)if(i1!=2) d1+=fabs(sisj[2][i1]);	
    printf(  "C_pd %8.6f",(double)d1/(nn/2));
#endif /* Dimer */
#if  CM(0,1,1)
    printf("\n niu.=");  /* occupation value <v0|n_s|v1> */
    for(i1=0;i1<nn;i1++)
     printf(" %8.6f",D(wop(&op_nis,(void *)"1",1,&i1,v0,v0))); /* niu */

    printf("\n niud=");  /* double occupation value (nu*nd)(i) */
    for(i1=0;i1<nn;i1++)
     printf(" %8.6f",D(wop(&op_nis,(void *)"3",1,&i1,v0,v0))); /* niud */

    for(i3=0;i3<sym.num_dkorr;i3++){
      double uu, dd, ud, du;
      int iw[2];
      iw[0]=i1=sym.dkorr[i3][0];
      iw[1]=i2=sym.dkorr[i3][1];
      printf("\n i-j %2d %2d nn % 9.6f",i1,i2,
           D(wop(&op_ninj,NULL,2,iw,v0,v0))); /* ninj */
      /* for SBase && Sud && nu==nd nuij is wrong, better take (nuij+ndij)/2 */
      printf(  " uu % 9.6f",uu=D(wop(&op_nisnjs,(void *)"1111",2,iw,v0,v0)));
      printf(  " dd % 9.6f",dd=D(wop(&op_nisnjs,(void *)"2222",2,iw,v0,v0)));
      printf(  " ud % 9.6f",ud=D(wop(&op_nisnjs,(void *)"1122",2,iw,v0,v0)));
      printf(  " du % 9.6f",du=D(wop(&op_nisnjs,(void *)"2211",2,iw,v0,v0)));
      printf(  " hh % 9.6f",   D(wop(&op_nisnjs,(void *)"3030",2,iw,v0,v0)));
#ifdef SBase
      /* we need symmetrized operators if we use spin-inversion */
      if (Sud && (nu==nd)) printf(  " uudd % 9.6f", 0.5*(uu+dd));
      if (Sud && (nu==nd)) printf(  " uddu % 9.6f", 0.5*(ud+du));
#endif
      /* hopping between site iw[0] and iw[1]    *
       *    sum_s c(+,i,s)c(-,j,s)+h.c.          */
      printf(  " cc % 9.6f",   D(wop(&op_cicj,NULL,2,iw,v0,v0)));
    }
#ifdef SBase
    if (Sud && (nu==nd))
     printf("\nWarning: use uudd and uddu instead of uu, dd, ud and du");
#endif
    /* example for F. Ouchni, makes sence for chains N>4 */
    if (strstr(Title,"chain"))
    { int iw[4]={2,4,0,2};
      if (nn>4) printf("\n <s(i)s(i+2)-s(i-2)s(i)> i= 2 % 9.6f",
        D(wop(&op_sisjsksl,NULL,4,iw,v0,v0)));
    }
#if CM(0,1,1)
/*  Definition by F. Ouchni (do you know about citations?)
 *  "bond-order wave" (BOW) (product of four fermionic operators)
 *  reference:PRB vol_67 page_205109
 *     BOW(r) = (-1)^r ( (\sum_{l} <B_{l,l+1} B_{l+r,l+r+1}>/N) - B^2)
 *          B = \sum_{l} <B_{l,l+1}>/N
 *  B_{l,l+1} = \sum_{spin} (C^{\dag}_{l s} C_{l+1 s} + h.c)
 *  sample: 
 *  correct? only if using symmetry? see m_tU.c
 *   m_tU 10 >daten.def  # v.0.22
 *      param=10,0,1,0,0,1,0.5,0.3333333,0.25,0.1 nud=2,2
 *   E0= 0.4921456 (ok)
 *        sum_k= -2 0 -1000 : <B(l,l+1)> l= 0  -0.642523 (see m_tU.c)
 *               <B(l,l+1) B(l+r,l+r+1)> r= 1   0.299550 OK
 *               BOW(r)                  r= 1   0.113287 OK (F.Ouchni)
 *               
 */
    if (strstr(Title,"chain"))  /* only for chains */
    {
      int iw[4]={0,1,1,2}, r=1;
      double b2=0, b4;
      if (nn>1) printf("\n <B(l,l+1)>              l= 0 % 9.6f",
        b2=D(wop(&op_cicj,NULL,2,iw,v0,v0)));
      if (nn>2)
      for (r=1; r<=nn/2; r++) {
        iw[2]=iw[0]+r;
        iw[3]=iw[1]+r;
        printf("\n <B(l,l+1) B(l+r,l+r+1)> r= %d % 9.6f",
          r, b4=D(wop(&op_cicjckcl,NULL,4,iw,v0,v0)));
        printf("\n BOW(r)                  r= %d % 9.6f",
          r, (1-((r&1)<<1))*(b4-b2*b2));
      }
    }
#endif

#else /* ! JJ */
    if (!num_sublat)
      mrule(v0,sym.sl,sym.subl); /* Marshall+output */
    for (i1=0;i1<num_sublat;i1++){
      for(i3=i2=0;i2<nn;i2++) if (sublat[i1][i2]+1>i3) i3=sublat[i1][i2]+1;
      mrule(v0,sublat[i1],i3); /* Marshall+output */
    }
#endif /* JJ */

    /* calculate structure factor S(q)/N^2 */
    for (i1=0;i1<num_sublat;i1++){
      for(i3=i2=0;i2<nn;i2++) if (sublat[i1][i2]+1>i3) i3=sublat[i1][i2]+1;
      if (i3==3) {  /* sublattices A, B, C => S(q=(4pi/3,0)) */
        d1=0;
        for (i2=0;i2<nn;i2++)
         for (i3=0;i3<nn;i3++)        /* A-A: cos=1, A-B: cos=-0.5 */
          d1+=sisj[i2][i3]*((sublat[i1][i2]==sublat[i1][i3])?1:-0.5);
        printf("\n SL%d S(q3)/N^2= % .8f",i1,d1/(nn*nn));
      }
    }

#if CM(1,0,0)
#if defined(N1) && defined(N2)
#if N1>1 && SBase==0
   /* local sublattice magnetization Msi^2=<1/N*sum_{j=1}^N{ti*tj*Siz*Sjz}>
    * sublattice magnetization Ms^2=1/N*sum_{i=1}^N{Msi^2}
    * ti=-1 for i odd (A), ti=+1 for i=even (B)      */
    printf(" Z= %8.5f",    D(wz(v0)));
    wtatb(&r1,&r2,v0);
    printf(" TA= %8.5f",   D(r1));
    printf(" TB= %8.5f",   D(r2));
    printf(" Dx= %8.5f",   D(wdx(v0)));
    printf(" Dy= %8.5f",   D(wdy(v0)));
    printf( " C= %8.5f",    D(wc(v0)));
#endif /* N1>1 */
#endif /* defined betts */
#endif

    if(vvv&1)x_out(stdout,v0,0);       /* x */
    if(vvv&1)x_out(stdout,v0,1);
    if(vvv&1)x_sort(stdout,v0,v1);
    if(vvv&1)printf(" t=%s",sclock(~0l));
    return(deg);}
/* ====================== ende chk3 ======================= */    
    
/* order degenerated EVs to Symmetry-Eigenvalues
 *    (makes only sence if symmetries are not used until yet)
 * EW( SymOp )= -1,+1, gleichzeitiges Diag. aller SymOps mit:
 * EW( Sym1 + 2*Sym2 + 4*Sym3 + ...) = 4+2+1, 4+2-1, 4-2+1, 4-2-1, ... 
 */
void chk2(tvec *v0,tvec *v1,int iv){
#if Sym+Sud           /* eigenwerte zu symmetrieoperatoren bestimmen */
    int i,j,k,d,dd,nrot,blk;static char nam[20],na2[20];ULong i1;
    double *xm,*xv,*xd,r;     /* Matrizen 1 & 2 */
    if(!A_ptr(v1)){ printf(" chk2 failed (v1==NULL)\n"); return; }
    xm=(double *)mymalloc( iv*iv*S_double,NULL);if(!xm)return;
    xv=(double *)mymalloc( iv*iv*S_double,NULL);
    xd=(double *)mymalloc(    iv*S_double,NULL);
    {  
      for(i=0;i<iv;i++)for(j=0;j<iv;j++)xm[i*iv+j]=0.0;
      /* --- for matrix use only sym-generators of l=2 (real!) Nov98 --- */
      for(dd=d=0;d<sym.numall;d++)if(sym.g[d])if(sym.l[d]==2){	
      /* use only commutative symmetries !!! gleichzeitig messbar ??? */
         printf("\nT%d=[[",d);
         for(i=0;i<iv;i++){      /* <vj|T*vi> */
             if(i>0)printf("],[");
             loadvec(v0,FileGS,i+1,-1);
             for(j=0;j<iv;j++){
                 if(j>0l)printf(",");
                 loadvec(v1,FileGS,j+1,-1);
                 xm[i*iv+j]+=((double)(1l<<dd))*(r=D(wop_t(v0,v1,d)));
                 printf("%10f",r);}}   
         printf("]]");dd++;} 
      jacobi2(&xm[0],iv,xd,xv,&nrot);
      printf("\nJACOBI rotations: %3d",nrot);
      printf("\neigenvalues:  ");
      for (j=0;j<iv;j++) printf("%12.6f",xd[j]);
      if(vvv&4){
        printf("\neigenvects:");
        for (j=0;j<iv;j++){ printf("\n%3d: ",j);
          for (k=0;k<iv;k++)printf("%12.6f",xv[k*iv+j]);}
      }
      if (nrot>0) {
        /* repeat chk3 with symmetrized eigenvectors */
        for(i=0;i<iv;i++){
          sprintf(nam,FileGS,i+1);
          sprintf(na2,FileTM,i+1);
          rename(nam,na2);
        }
        for(i=0;i<iv;i++){
          clrvec(v0);
          for(j=0;j<iv;j++){
            loadvec(v1,FileTM,j+1,-1);
            for(blk=0;blk<B_NUM;blk++)
            for(i1=0l;i1<b_len[blk];i1++)
              v0->v[blk][i1]+=M_d2f(M_f2d(v1->v[blk][i1])*xv[j*iv+i]);
          }
          savevec(v0,FileGS,i+1,-1);
          chk3(v0,v1,i+1);
        }
        for(i=0;i<iv;i++){
          sprintf(na2,FileTM,i+1);
          remove(na2);if(vvv&1)printf(" remove %s ",na2);}
      }
    }  
    myfree((void *)xm,NULL);
    myfree((void *)xv,NULL);
    myfree((void *)xd,NULL);
#endif    
    return;}
    
/* sortieren von indizes mit shellsort, R.Sedgewick: Algorithmen in C */
/* input: a,n;  output: ia; Nov98 JS +error in 1st Auflage */
void shellsort(double a[],int ia[],ULong n){  /* ULong statt int Mar99 JS */
  int v; ULong i,j,h;
  if(vvv) printf(" shellsort");
  for(i=0;i<n;i++) ia[i]=(int)i;	/* set indizes, (int) ??? Mar99 */
  for(h=1;h<=n/9;h=3*h+1);		/* using int or ULong ??? confusing */
  for(;h>0;h/=3)
   for(i=h-1;i<n;i++){
     v=ia[i]; j=i;
     while(j>=h && a[ia[j-h]]>a[v]){
       ia[j]=ia[j-h]; j-=h; }
     ia[j]=v;
   }
}

/* ================== USING LAPACK (linear algebra package) ================
 DSYEV - compute all eigenvalues and, optionally, eigenvectors of a real
         symmetric matrix A (LAPACK)
 ZHEEV - compute all eigenvalues and, optionally, eigenvectors of a complex
         Hermitian matrix A
 Makefile: add DFLAGS= -DLAPACK and system specific options LIB=...
 You can test LAPACK before using it with spinpack:
   Tru64: cc -migrate lapack_test.c -ldxml; PARALLEL=4; KMP_STACKSIZE=262144
   IRIX:  cc lapack_test.c -lscs[_i8][_mp] # [integer8][multi-processor]
   linux: gcc lapack_test.c -llapack -lf2c # lapack 3.0 + update + blas 3.0
   linux: gcc lapack_test.c -lacml -lg2c   # acml + f2c-Nachfolger=g2c gcc-3.4
 time[s] = 4e-8 * n1^3 (wf: GS160-alpha-731MHz dsyev nev=1 double ) 
 time[s] = 8e-8 * n1^3 (wf: GS160-alpha-731MHz zheev nev=1 complex)
 example:
   4x4-square-cplx sym=q_0_0_0+ n1=365 e0=-11.22848321
   jacobi=21s  lapack=1s  (alpha731MHz, real)
   jacobi=     lapack=1s  (alpha731MHz, complex)
   i686-2.6GHz n1=1617 zheev nev=1 139s  44MB # lapack-3.0 SuSE-9.2
   i686-2.6GHz n1=1617 zheev nev=0  24s  44MB
   i686-2.6GHz n1=1617 dsyev nev=1  44s  23MB # lapack-3.0 SuSE-9.2
   i686-2.6GHz n1=1617 dsyev nev=0   8s  23MB
   i686-2.6GHz n1=3583 dsyev nev=0  85s 103MB
   i686-2.6GHz n1=4704 dsyev nev=0 189s 176MB v2.22
   AOpt-2.2GHz n1=5481 dsyev nev=0 281s 240MB v2.23 4m..5m14s (259M/231M) acml=5m11s
                 10584 dsyev nev=0  ??  880MB v2.23 (vsz reduced)
                 16852 zheev nev=0 314m       v2.24 loki-Opteron-2.2GHz
                 18018 zheev nev=0 13h=48600s v2.22 8e-9s*n1^3 marvel
                 25000 zheevd     1e5s (ca.)
                  
 * * * WARNING * * *
 LAPACK is a Fortran-Library. There is no garanty that
 this C interface will work well on every system!
 SuSE-9.2 + lapack-3.0-920 = OK (n1>5400 wrong Es, spur ok)
  valgrind: Warning: set address range perms: large range 240330888, a 0, v 1
   5481^2*8 = 240330888

 ToDo: extract DSYEV and ZHEEV and convert to C routines
       this would also allow to use long (8byte) instead of int (4byte) for
       bufsize
*/
#ifdef LAPACK
#if (VecType & 4) == 0
#ifdef __cplusplus
extern "C"    /* C++ does shall not create special object names */
#endif
void dsyev_(
        const char *jobz,               /* (in) "N"=NoVectors, "V"=Vectors */
        const char *uplo,               /* (in) "U"=UpperTriangleA, "L"=LowerTA */
        const int *n,                   /* (in) order of matrix */
        double *a,                      /* a[n][lda] (in/out) */
        const int *lda,                 /* (inp) leading dimension >=max(1,n) */
        double *w,                      /* w[n] (out) eigenvalues */
        double *work,                   /* work[lwork] (workspace/out) */
        const int *lwork,               /* (in)   >= max(1,3*n-1) better (nb+2)*n */
        int *info                       /* (out) ==0 on success */
        );
#else
extern "C"  /* let the name of the object link unchanged */
void zheev_(
        const char *jobz,               /* (in) "N"=NoVectors, "V"=Vectors */
        const char *uplo,               /* (in) "U"=UpperTriangleA, "L"=LowerTA */
        const int *n,                   /* (in) order of matrix */
        double *a,                      /* a[n][lda][2] (in/out) */
        const int *lda,                 /* (inp) leading dimension >=max(1,n) */
        double *w,                      /* w[n] (out) eigenvalues */
        double *work,                   /* work[lwork][2] (workspace/out) */
        const int *lwork,               /* (in)   >= max(1,2*n-1) better (nb+2) */
        double *rwork,                  /* (in)   >= max(1,3*n-2) better (nb+2) */
        int *info                       /* (out) ==0 on success */
        );
#endif
#endif

/* ??? use hbuf without ev!
 * bei komplexen (hermitisch) Matrixen vom Typ: A+iB
 *   einfach [[ A,-B], [ B, A]] jacobieen, dann alle EWs doppelt.
 *   EVs: (u,v) -> u+iv
 * Driver for routine jacobi fuer symmetrische reelle Matrizen
 * jacobi sparc-Ultra1-143MHz(boson): time/s = 1.5e-6 dim ^ 3.2
 * --------------------------  Matrizen ----------------------------------- */
void fulldiag(tvec ev[],int nev){
    int nrot,*ix,blk,ii; ULong k,i,j,iv=1,jv=1;
    double *xm,*xv,*xd,xr,xi,trace1,trace2,h12,i12; cplx hh;   /* Matrizen 1 & 2 */
    thbuf *hbuf;
    minfo_t m_xm = {NULL,0,0,"tmp/xm.map",NULL};
    minfo_t m_xv = {NULL,0,0,"tmp/xv.map",NULL};
    minfo_t m_xd = {NULL,0,0,"tmp/xd.map",NULL};
    minfo_t m_ix = {NULL,0,0,"tmp/ix.map",NULL};
    if(vvv)printf("\nfulldiag nev=%d",nev); xi=0;
#if VecType & 4    		/* Okt99 JS */
    iv=2; /* trick: put real and imag-part in one real matrix */
    jv=2; /* trick to use jacobi for complex H via [[Hr,0],[0,Hi]] */
#ifdef LAPACK
    jv=1;
#endif
#endif
    /* standart jacobi and LAPACK expects simple vectors, convert block form */
    /* add 1 for the case n1=1, where Lapack fails */
    xm=xv=xd=NULL; trace1=trace2=0; h12=i12=0;
    /* int overflow ? */
#ifndef LAPACK
    xm=(double *)mymalloc(jv*n1*iv*n1*S_double,&m_xm); /* Matrix_H-in =  */
#endif
    xv=(double *)mymalloc(jv*n1*iv*n1*S_double,&m_xv); /* eigenvects-out */
    xd=(double *)mymalloc(      iv*n1*S_double,&m_xd); /* eigenvalues-out */
    ix=   (int *)mymalloc(      iv*n1*S_int,&m_ix);    /* sort-idx-out */
    for(i=0;i<iv*n1;i++) ix[i]=(int)i; /* initialize sort-index (LAPACK) */
    hbuf=alloc_hbuf();
    if((xm!=NULL || xv!=NULL) && xd!=NULL && ix!=NULL){
      if (vvv) printf("\n store matrix H ...");
      /* generate a simple matrix, store all elements to xm[] */
      if (xm) for(i=0;i<iv*n1*jv*n1;i++) { xm[i]=0.0; }
      if (xv) for(i=0;i<iv*n1*jv*n1;i++) { xv[i]=0.0; }
      for(blk=0;blk<B_NUM;blk++) for(i=0;i<b_len[blk];i++){
        hbuf->n=0; /* reset buffer */
        hamilton_nhv(b_ofs[blk]+i,vnul,hbuf,8); /* get hbuf.el.j+r */
        /* printf("\n n=%d ",hbuf->n[0]); */
        for(ii=0;ii<hbuf->n;ii++){
          j =hbuf->el[ii].j;
          hh=hbuf->el[ii].r;
          /* if (i+b_ofs[blk]==j) trace1+=Re(hh); */ /* just as a test */
          if (vvv&32) printf("\n H blk= %2d xy= %3ld %3ld r= %6g ",
             blk, i+b_ofs[blk], j, D(hh));
#ifdef LAPACK
          xv[((i+b_ofs[blk])*n1+j)*iv  ]+=Re(hh);
#if VecType & 4
          xv[((i+b_ofs[blk])*n1+j)*iv+1]+=Im(hh);
          i12+=Im(hh)*Im(hh); /* test for a reel matrix */
#endif
#else /* jacobi, construct [[ A,-B], [ B, A]] from [A+iB] */
          xm[(   i+b_ofs[blk])*iv*n1+(   j)]+=Re(hh);
#if VecType & 4
          xm[(n1+i+b_ofs[blk])*iv*n1+(n1+j)]+=Re(hh);
          xm[(n1+i+b_ofs[blk])*iv*n1+(   j)]+=Im(hh);
          xm[(   i+b_ofs[blk])*iv*n1+(n1+j)]-=Im(hh);
          i12+=Im(hh)*Im(hh); /* test for a reel matrix */
#endif
#endif
        }
      }
      if (vvv) printf(" t=%s",sclock(~0l));
#if VecType & 4
      if (i12==0) printf("\n Warning: You are wasting more than 50%% memory"
                " and cpu time when using real matrix H in complex mode!\n");
#endif
#ifdef LAPACK
      for(i=0;i<n1;i++) { trace1+=xv[(i*n1+i)*iv]; } /* build the trace */
      for(i=  0;i<n1;i++)         /* as a check sum upper left elements */
      for(j=i+1;j<n1;j++) {  h12+=xv[(i*n1+j)*iv]; }
      ii=(int)n1;              /* buffer for n1 */
      nrot=(int)(3*n1); /* buffer for lwork >= max(1,3*n-1) better (nb+2) */
      /* ToDo: problem if nrot is 4 byte and n1^2 is larger than 2e9 */
      if (  (3 *n1*iv)*S_double
          !=(3.*n1*iv)*S_double ) E0("integer overflow");
      blk=-1;                  /* buffer for info, set by lapack */
      /* use  ev as matrix  and  xm as workbuffer */
      myfree((void *)xm,&m_xm);
      xm=(double *)mymalloc(nrot*iv*S_double,&m_xm); /* work-space */
#if (VecType & 4) == 0   /* reel symmetric matrix, iv=1 */
      printf("\n LAPACK dsyev");
      dsyev_(((nev)?"V":"N"),"U",&ii,xv,&ii,xd,xm,&nrot,&blk);
      /* there is probably a bug in LAPACK-1.1,
       * I got sometimes segfaults freeing xm (small n1 and nrot=n1*n1+1) */
      printf("_info=%d (0=ok)",blk);
#else                 /* hermitian matrix, iv=2 */
      /* nrot/=2; ** use half of mx as work-buffer, other half as rwork-buffer */
      minfo_t m_rw = {NULL,0,0,"tmp/rw.map",NULL};
      double *rwork=(double *)mymalloc(nrot*sizeof(double),&m_rw);
      if (!rwork) { E0(" malloc *rwork failed - skip zheev"); }
      printf("\n LAPACK zheev");
      /* valgrind shows that zhemv_ of blas-3.0 accesses WORK+len=xm+nrot...
       * so we malloc more elements than nrot=LWORK counts 
       */
      if (rwork)
        zheev_(((nev)?"V":"N"),"U",&ii,xv,&ii,xd,xm,&nrot,rwork,&blk);
      printf("_info=%d (0=ok)",blk);
      if (rwork) myfree(rwork,&m_rw); 
  /* if not freed, zheev causes segfault after about 7 runs on Tru64-cxx */
#endif
#else
      for(i=0;i<n1;i++) { trace1+=xm[(i*n1*iv+i)]; } /* build the trace */
      for(i=  0;i<n1;i++)         /* as a check sum upper left elements */
      for(j=i+1;j<n1;j++) {  h12+=xm[(i*n1*iv+j)]; }
      printf(" JACOBI");
      jacobi2(&xm[0],(int)(iv*n1),xd,xv,&nrot);
      printf(" rotations: %3d",nrot);
      shellsort(xd,ix,iv*n1);		/* sort xd[ix[i]] */
      if (iv>1) for (j=0;j<n1;j++){   /* remove every 2nd */
        ix[j]=ix[j*2]; /* does not work? */
      }
#endif
      printf(" t=%s\n eigenvals=",sclock(~0l));
      for (j=0;j<n1;j++){ trace2+=xd[ix[j]]; printf(" %+12.8f",xd[ix[j]]); }
      printf("\n  traceH= %e sumE= %e traceH-sumE= %e\n sum_h12= %e",
             trace1, trace2, trace2-trace1, h12);
      if(vvv&4)printf("\n number eigenvals eigenvects (sorted):");
      /* convert simple vectors to block form for calling <O>-functions */
      if (nev)
      for (j=0;j<n1;j++){ /* every eigenvect */
        if(j<NEW)ew[j]=xd[ix[j]];
        if(vvv&1)printf("\n%3ld: %+12.8f",j,xd[ix[j]]);
        for(blk=0;blk<B_NUM;blk++) for(k=0;k<b_len[blk];k++){
#ifdef LAPACK   /* this is hopefully right, normalization? */
          xr=           xv[((b_ofs[blk]+k)+n1*j)*iv  ];
          if (iv>1) xi=-xv[((b_ofs[blk]+k)+n1*j)*iv+1];
          /* the minus sign was found empirically (N=6=4+2, k=-2 1) */
#else
          xr=          xv[(b_ofs[blk]+k   )*iv*n1+ix[j]];
          if (iv>1) xi=xv[(b_ofs[blk]+k+n1)*iv*n1+ix[j]];
#endif
          if(vvv&4){ /* output all koefficients of the eigenstate */
             printf(" ");
             if(iv>1)  printf("("); outmpl(stdout,xr);
             if(iv>1){ printf(","); outmpl(stdout,xi); printf(")"); }
          }
          /* copy ev in blk-structure */
          if(!A_ptr(ev)) continue;
          ev[0].v[blk][k] = M_d2f(C(xr,xi)); /* ignore xi if not complex */
        }

        /* call <ev|O|ev>-functions here, SiSj-example: */
        if(cfg_sisj&5)
        { /* new block necessary to allow definition of int sites */
          int i3,sites[2];   /* must follow the left bracket */
          /* could be problematicaly on degenerate states! not proofed */
          for(i3=0;i3<sym.num_dkorr;i3++){
            sites[0]=sym.dkorr[i3][0];
            sites[1]=sym.dkorr[i3][1];
            printf(" Z%dZ%d= %9.6f", sites[0], sites[1],
                   D( wop(&op_zizj,NULL,2,sites,ev,ev) ));
            if(cfg_sisj&1)
            printf(" S%dS%d= %9.6f", sites[0], sites[1],
                   D( wop(&op_sisj,NULL,2,sites,ev,ev) ));
          }
        }

        /* normvec(ev);        LAPACK not normalized? */
        if(cfg_sisj&2) wss(ev,ev); /* output S^2 */
      }
      if (vvv&4) printf("\n");
      if (A_ptr(ev))
      for (j=0;j<(ULong)nev;j++){    /* copy eigenvects */
        for(blk=0;blk<B_NUM;blk++) for(k=0;k<b_len[blk];k++){ 
#ifdef LAPACK   /* this is hopefully right */
          xr=           xv[(b_ofs[blk]+k+n1*j)*iv  ];
          if (iv>1) xi=-xv[(b_ofs[blk]+k+n1*j)*iv+1];
#else
          xr=          xv[(b_ofs[blk]+k   )*iv*n1+ix[j]];
          if (iv>1) xi=xv[(b_ofs[blk]+k+n1)*iv*n1+ix[j]];
#endif
          ev[j].v[blk][k] = M_d2f(C(xr,xi));
        }
      }
    }
    myfree((void *)ix,&m_ix);
    myfree((void *)xm,&m_xm);
    myfree((void *)xv,&m_xv);
    myfree((void *)xd,&m_xd);
    free_hbuf(hbuf);
    return;}

/* ===================== Parameter lesen/schreiben  ======================*/

char *strsub(char *sd,const char *ss,int i1,int i2){/* copy ss[i1..i1+i3-1] */
 int i3;for(i3=0;i3<i2;i3++)sd[i3]=ss[i1+i3];sd[i2]=0;return(sd);}
char *fk(const char *ss,int i2){ /* get i2-tes element from komma-list */
 static char s1[512];int i1,i3,i4,i5;char s2;
 s1[0]=0;
 i1=0;  /* pos letztes komma +1 */
 i3=0;  /* klammerebene */
 i4=0;  /* komma-nr */
 for(i5=0;i5<(int)strlen(ss)+1;i5++){
  s2=ss[i5];if(s2==0)s2=',';
  if(s2=='(') i3++;else
  if(s2==')') i3--;else
  if((s2==',') && (i3==0)){ 
    i4++; if(i4<i2) i1=i5+1; else break;  } }
 if((i4>=i2) && (i2>0))strsub(s1,ss,i1,i5-i1);
 if((s1[0]=='(')&&(s1[strlen(s1)-1]==')'))strsub(s1,s1,1,(int)strlen(s1)-2);
 return s1; }


cplx atoc(char *s){	/* (r,w) => r*exp(I*w*Pi) */
  zahl x=Z(0),y=Z(0);int i=0;
  while(s[i]!=0 && s[i]!=',')i++;
  x=Z(atof(s));if(s[i]==',')y=Z(atof(&s[i+1]));
#if VecType & 4     
  return polar(x,y*M_PI);}
#else
  if(y!=0)E0("imag(r)!=0"); return C(x,0);}
#endif     

void outpara(FILE *in){
  int i;
  fprintf(in," param=");
  for(i=1;i<numpara;i++){
    fprintf(in," %.9g",(double)para[i]);
    if(i<numpara-1)fprintf(in,",");
  } 
  fprintf(in,"\n# p1= %lg\n# p2= %lg  ... can also be used\n",
          para[1],para[2]);
  fflush(in);
  return;
}

int set_ww(){
  int i;
  for(i=0;i<nw;i++){
    ww.co[i]=cos(M_PI*para[ww.w[i]]*ww.ex[i]);
    ww.si[i]=sin(M_PI*para[ww.w[i]]*ww.ex[i]);
  }
  return 0;
}

int scan_ud(char *s1,int sum){
  if (sum) {  /* add values, used for loops */
    nu+=atoi(fk(s1,1));
    nd+=atoi(fk(s1,2));
  } else {
    nu=atoi(fk(s1,1));
    nd=atoi(fk(s1,2));
  }
  if(nu>nn)nu=nn;
  if(nd>nn)nd=nn;
#if CM(1,0,0)
  if(nu+nd!=nn){ nu=nn/2;nd=nn-nu;
    printf("\nwarning: nu+nd!=N set nu=%d nd=%d",nu,nd); }
#endif  
#if CM(0,1,0)
  if(nu+nd>nn){ nu=nn/2;nd=nn-nu-1;
    printf("\nwarning: nu+nd> N set nu=%d nd=%d",nu,nd); }
#endif  
  return 0;
}

int scan_para(char *s1, int sum){
  int i;
  if (sum)  for(i=1;i<numpara;i++){para[i]+=atof(fk(s1,i));}
  else      for(i=1;i<numpara;i++){para[i]= atof(fk(s1,i));}
  set_ww();
  return 0;
}

void inppara(char *s1){
  int i;
  if(vvv)printf("\nwarning: do not use :-command, use new param=,nud= instead!");
  scan_ud(s1,0);
  for(i=1;i<numpara;i++){para[i]=atof(fk(s1,i+2));}
  set_ww();
  return;
}

/* =========================== dies und das (diverses) ================= */

void testsym(){
}

/*
 * search end of line
 */
char *scan_eol(char *s){
  char *s2;
  s2=strchr(s,'#');if(s2) return s2; /* comment-line */
  s2=strchr(s,'%');if(s2) return s2; /* comment-line */
  s2=s+strlen(s);
  return s2;
}
/*
 * search "vnam=" in s, get position of next char, ret 0=not found
 *  ToDo: search expression "p[0-9]*=" or p%d=%f ?
 */
char *scan_var(char *s,const char *vnam){
  char *s1,*s2;
  if((s1=strstr(s,vnam))==NULL)return NULL;s1+=strlen(vnam);
  s2=scan_eol(s);if(s2)if(s2<s1)return NULL; /* comment */
  if(s1[0]!='='){if(vvv&1)printf(" %s=???",vnam);return NULL;} 
  s1++;
  return s1;}

int scan_int(char *s,const char *vnam,int *var){
  char *s1;
  if( (s1=scan_var(s,vnam))==NULL ) return -1;
  if(var){ *var=atoi(s1);if(vvv&1)printf(" %s=%d",vnam,*var);}
  return 0;}

int scan_inta(char *s,const char *vnam,int *var,int len){
  char *s1,*s2; int i=0;
  if( (s1=scan_var(s,vnam))==NULL ) return -1;
  s2=scan_eol(s); len=(int)(s2-s1);
  if(var){
   if(vvv&1)printf(" %s=",vnam);
   for(i=0;i<len;i++){
    var[i]=(int)strtol(s1,&s2,10);
    if(s1==s2 || s2[0]==0) break;
    if(vvv&1)printf(" %d",var[i]);
    s1=s2;
   }
   if(vvv&1)printf("\n");
  }
  return i;}

/* search "vnam=" in s, set value to var, ret 0=found,1=not found,2=err
   last modify 1998-139 */
int scan_dbl(char *s,const char *vnam,double *var){
  char *s1;
  if( (s1=scan_var(s,vnam))==NULL ) return -1;
  if(var){ *var=strtod(s1,NULL);if(vvv&1)printf(" %s=%g",vnam,*var);}
  return 0;}

int clr_status(){ FILE *f1;f1=fopen("tmp/status","w");fclose(f1);return 0;}
int wl_status(ULong n1){ FILE *f1;
  if(vvv)printf(" write tmp/status");
  f1=fopen("tmp/status","w");fprintf(f1," %lu",n1);
  fclose(f1);return 0;}
int rl_status(ULong *n1){ FILE *f1;
  if(vvv)printf(" load tmp/status");
  f1=fopen("tmp/status","r");
  if(!f1) { printf("ERROR open tmp/status\n"); n1=0; return 1; }
  fscanf(f1," %lu",n1);
  fclose(f1);return 0;}

int p_mask_ini(int nn){
  int i,j;
  /* --- initialize bitmasks for faster parity() --- */
  for(i=0;i<nn;i++)for(j=0;j<nn;j++)
    if(i<j) p_mask[i][j]=(~(~(tbase1)0 << j << j)) & (~(tbase1)0 << i << i << 2);
    else    p_mask[i][j]=(~(~(tbase1)0 << i << i)) & (~(tbase1)0 << j << j << 2);
  return 0;
}

void ns_thread( void *ptr); /* see hilbert.c */
void wopij_block( void *ptr ); /* see xval.c */
void wop_block( void *ptr ); /* see xval.c */
void diag2_thread( void *ptr ); /* see diag.c */

/* void-function for pthreads */
void main_pthread( void *ptr ){
  volatile main_pts *pp=(volatile main_pts *)ptr;
  printf(" main_pthread[%d]: start\n",pp->num);
#ifdef CONFIG_PTHREAD
  for(;;) {  /* endless loop */
    pthread_mutex_lock(&pt_mutex1);
    while (pp->task==0)
      pthread_cond_wait(&pt_cond1,&pt_mutex1); /* wait for broadcast */
      /* ToDo: better have one(two) condition variable(s) per thread */
    pthread_mutex_unlock(&pt_mutex1);

    if (pp->task<0) break;
    pp->worker( pp->data ); /* call worker function for this thread */

    pthread_mutex_lock(&pt_mutex1); /* ToDo: check for race condition? */
    pp->task=0; /* ready */
    pthread_cond_signal(&pt_cond2); /* wake up master */
    pthread_mutex_unlock(&pt_mutex1);
  }
#endif
#ifdef CONFIG_PTHREAD
  pthread_exit(0);
#elif defined(CONFIG_MPI)
  MPI_Finalize();
#endif
}

/* ---------------------------- MAIN --------------------------------- */
int    main(int argc,char *argv[]){
  static char nam1[12],s1[500],*ss; ULong n1max=1000;
  int i,ii,i1,j,itr=0,iv,nev,ne0,blk,nruns=0;
  FILE *in1,*in2=NULL,*fev[NEV];        /* in2 is inline-backup */
  double r1;
  tvec v0,v1,ev[NEV]; /* large vectors */
#ifdef CONFIG_PTHREAD
  pthread_t pt[B_NUM];
#endif
#ifdef CONFIG_MPI
  int mpi_n=1, mpi_i=0;
#endif
  minfo_t m_v0[B_NUM],m_v1[B_NUM],
          m_l2 = {NULL,0,0,"tmp/l2.map",NULL};
  setvbuf(stdout, (char *)NULL, _IONBF, 0); /* no buffer */
  for(j=0;j<B_NUM;j++){
    m_v0[j].p=NULL; m_v0[j].l=0; m_v0[j].mode=0; m_v0[j].ff=NULL;
    sprintf(m_v0[j].name,"tmp/v0_%03d.map",j);
    m_v1[j].p=NULL; m_v1[j].l=0; m_v1[j].mode=0; m_v1[j].ff=NULL;
    sprintf(m_v1[j].name,"tmp/v1_%03d.map",j);
    v0.v[j]=v1.v[j]=(mcplx *)NULL;	/* NULL = not allocated */
    v0.id=0;v1.id=1;		/* identification */
    for(i=0;i<NEV;i++){ev[i].id=8+i;ev[i].v[j]=(mcplx *)NULL;}
  } 
  l2b=NULL; norm2=NULL; l1=NULL; fev[0]=NULL; /* initialization */
  iv=0; algo=0; x_p=3;n1=0l; nn=NN; nw=0*Nw; ne0=0;
  sym.subl=0; /* if 0 auto detection will be used */
  hfmax=1000000l/(Hsize/HBLen);		/* max. 1MB Filesize hxy.tmp */
  x_max=5; if(MAXx<x_max) x_max=MAXx;   /* max. num. of output-configs */
  /* bug: x_max=min(5,MAXx); - this gives warnings on SGI-CC, JS Mar99 */
  pew=2;max_ea=1;nev=NEV; cfg_sisj=1;
  usemem=0l;maxmem=MaxMem;itime();	/* ini itime */
  printf("\nSPINPACK version "version_string" (JS), compiled at "__DATE__" "__TIME__"\n" 
           "Model=%s Title= %s\n",CM("JJ","tJ","tU"),Title);
#ifdef __GNUC__
  printf(" Compiler: GNUC %d.%d\n",__GNUC__,__GNUC_MINOR__);
#endif
#ifdef __DECCXX_VER
  printf(" Compiler: DECCXX %d\n",__DECCXX_VER);
#endif
#ifdef __SUNPRO_CC
  printf(" Compiler: SUNPRO_CC 0x%x\n",__SUNPRO_CC);
#endif
#if defined(__mips) && defined(_COMPILER_VERSION)
  printf(" Compiler: MIPS_CC %d\n",_COMPILER_VERSION);
#endif
#ifdef HAVE_ZLIB
  printf(" using ZLIB\n");
#endif
#ifdef _Vlint_h
  printf(" using class Vlint for %d-bit emulation (slow)\n",sizeof(vlint)*8);
#endif
#ifdef CONFIG_PTHREAD
  printf(" using PTHREAD with %d threads\n",B_NUM);
  /* IRIX, True64 and Linux works with NULL=default, but SunOS does not */
  pthread_attr_init (&pt_attr);
  pthread_attr_setscope (&pt_attr, PTHREAD_SCOPE_SYSTEM);
  pthread_mutex_init(&pt_mutex1,NULL);
  pthread_mutex_init(&pt_mutex2,NULL);
  pthread_cond_init(&pt_cond1,NULL); /* correct init? */
  pthread_cond_init(&pt_cond2,NULL); /* correct init? */
  /* create main threads */
  for (i=0;i<B_NUM;i++) {
    main_pt[i].num=i;     /* put thread number to child */
    main_pt[i].data=NULL; /* for first do nothing */
    main_pt[i].task=0;    /* initialize */
    if( pthread_create((pthread_t *)&(pt[i]),
                       (const pthread_attr_t *)&pt_attr,
                       (void * (*)(void *)) &main_pthread,
                       (void *)  &(main_pt[i]) ) !=0 )  F0("pthread_create");
  }
#elif defined(CONFIG_MPI)
  if (MPI_Init(&argc, &argv) != MPI_SUCCESS) exit(1);
  MPI_Comm_size(MPI_COMM_WORLD, &mpi_n);
  MPI_Comm_rank(MPI_COMM_WORLD, &mpi_i);
  printf(" using MPI with %d threads\n",mpi_n);
  if (mpi_i>0) {
    i=mpi_i-1; 
    main_pt[i].num=i;
    main_pt[i].data=NULL; /* for first do nothing */
    main_pt[i].task=0;    /* initialize */
    main_pthread( (void *)&(main_pt[i]) );
    exit(0);
  }
#endif
   printf(" using Sud=%d Ham1=%d Ham2=%d Ham3=%d VecType=%d\n",
          Sud,Ham1,Ham2,Ham3,VecType);

  ini_handler(vvv); /* signalhandler SIGUSR1 sighand.h moved to here v1.6.4 */
  /* create the child early to save memory on pipe or fork */

  sub_ini();		/* v1.6.1 start child for gzip */
  initvars();		/* define the model from daten.def ToDo: later *in */
  initmasks(nn);	/* initialize bitmasks for lintab/sym/etc. */
  p_mask_ini(nn);       /* initialize bitmasks for parity() */

  sym.wud=+1;
  for(i=0;i<MaxSym;i++){ 
    sym.k[i]=0;sym.w[i]=1;sym.l[i]=2;/* sym.d[i][0]=0;sym.m[i][0]=M0F; */
    for(j=0;j<nn;j++)sym.i[i][j]=j; }

  sprintf(nam1,"daten.i");
  i=0;while(++i<argc){ ss=argv[i];
    if(ss[0]=='-'){
      if(ss[1]=='v'){ vvv=atoi(ss+2);continue; }
      if(ss[1]=='i'){ sprintf(nam1,"%.11s",ss+2);continue; }
    }
    printf("options: [-v<n>] [-ifile]\n");return 1;}
  if(vvv&1)printf(" llong=%d long=%d int=%d zahl=%d mzahl=%d cplx=%d"
                  " mcplx=%d hxy=%d tbase1=%d tbase=%d\n",
    (int)sizeof(ULLong),(int)Lsize,(int)sizeof(int),
    (int)sizeof(zahl),(int)sizeof(mzahl),(int)sizeof(cplx),(int)sizeof(mcplx),
    (int)Hsize/HBLen,(int)sizeof(tbase1),(int)sizeof(tbase));

  for(i=0;i<2*nw;i++)if(iw[i>>1][i&1]>=nn) F1("site>=NN iw[%u]",i>>1);
  for(i=0;i<nw;i++){  ww.ex[i]=1;
    if(iw[i][0]>iw[i][1]){		/* lowest index first */ 
      j=iw[i][0];iw[i][0]=iw[i][1];iw[i][1]=j;
      ww.si[i]=-ww.si[i];ww.ex[i]=-1;}}


  if((in1=fopen(nam1,"rt"))==NULL){	/* create DEMO-infile */
    if((in1=fopen(nam1,"wt"))==NULL)F1("open %s",nam1)
    fprintf(in1,"# test for lock-file and create one (Linux,OSF1,..)\n");
    fprintf(in1,"!if test -r tmp/pid; then echo \"Warning: [tmp/pid] is running or was killed (please delete tmp/pid)\"; kill $PPID; sleep 10; else echo $PPID >tmp/pid; fi\n");
    fprintf(in1,"# remove (#) on next line to get cpu.log (Linux,IRIX,SunOS,OSF1)\n");
    fprintf(in1,"#! while ps -o pid,pcpu,time,etime,rss,vsz,inblock,oublock,cmd -p $PPID; do sleep 10; done >cpu.log & # for OSF\n");
    fprintf(in1,"#! while ps -o pid,pcpu,time,etime,args -p $PPID; do sleep 10; done >cpu.log & # other\n");
    fprintf(in1,"verbose=%d\nx%d %ld\n",vvv,x_p,x_max);
    fprintf(in1,"save_mode=%d # 1:store checkpoints, 2,3:set up after crash\n",save_mode);
    fprintf(in1,"last_point=0 # last checkpoint before crash\n");
    fprintf(in1,"maxmem=%.2e  # max. memory\n", (double)maxmem);
    fprintf(in1,"maxfile=%.2e # max. filesize/HBlock\n",((double)hfmax)*D(Hsize/HBLen));
    fprintf(in1,"pew=%d  # number of EWs for convergence proof\n",pew);
    fprintf(in1,"nev=1  # number of lowest eigenvectors nev=0..%d\n",NEV);
    fprintf(in1,"ne0=0  # offset of lowest eigenvectors ne0=0..%d\n",NEW-1);
    fprintf(in1,"max_ea=%d  # proof for degeneracy max_ea>0\n",max_ea);
    fprintf(in1,"startvec=%d\n",startvec);
    fprintf(in1,"z_anisotropy=%.2f\nxy_anisotropy=%.2f\n", h_zpara, h_xypara);
    fprintf(in1,"newtime # reset the internal clock\n"
                "sisj=1  # bitpattern: 1 <sisj>; 2 <ss> (0, 1 or 2)\n"
                "sym_ud=+1    # symmetries\nsym_k= 0 0 0\n"
                "nud=%d,%d\n",nu,nd);
    outpara(in1);
    fprintf(in1,"a%d\n!date  # execute date-command\n%%",algo);
    fprintf(in1,"!rm -f tmp/pid  # finaly remove lock-file");
    printf("\n * * * default daten.i was created, please edit and start again * * *\n\n");
    return 0;
  }
  n2=0l;
#if S_long*8 > CM((NN/2+NN%2),NN,NN)
  n2=1l<< CM( (nn/2+nn%2) , nn , nn );
#endif
  paini();for(;;){
    if (feof(in1)){ if (in2==NULL) break; in1=in2; in2=NULL; } /* restore */
    s1[0]=0;fgets(s1,500,in1);  /* without \n ?? , .begin ... .end */
    if(s1[0]=='#' || s1[0]=='%' || s1[0]==0 || s1[0]=='\n'){ /* nop */ } else
    if(s1[0]=='!'){printf(s1);system((char *)&s1[1]);/* exec arg */} else
    if(in2==NULL && strncmp(s1,"include",7)==0) { /* max include depth = 1 */
        for (ss=s1+8;*ss!=0 && *ss>='0';ss++); *ss=0;
        in2=in1; in1=fopen(s1+8,"rt");
        printf("\ninclude %s",s1+8);
        if(!in1) { in1=in2; printf("failed"); }
        continue;
      } else
    if(!scan_int(s1,"max_ea",&max_ea)){max_ea=max(1,max_ea);} else
    if(!scan_int(s1,"save_mode",&save_mode)){ } else
    if(!scan_int(s1,"last_point",&checkpoint)){ } else
    if(!scan_int(s1,"nev",&nev)){nev=min(max(0,nev),NEV);} else
    if(!scan_int(s1,"ne0",&ne0)){ne0=min(max(0,ne0),NEW-1);} else
    if(!scan_int(s1,"pew",&pew)){pew=min(max(1,pew),NEW);} else
    if(!scan_int(s1,"startvec",&startvec)){} else
    if(!scan_int(s1,"sym_ud",&sym.wud)){ } else
    if(!scan_int(s1,"sym_k",NULL)){ /* in daten.k schreiben? */
      for(i=0;i<MaxSym;i++)sym.kgen[i]=0;
      scan_inta(s1,"sym_k",sym.kgen,MaxSym); } else
    if(!scan_int(s1,"SL",NULL)){ /* set sublattice 0=A 1=B etc. */
      for(i=0;i<nn;i++)sublat[num_sublat][i]=0;
      scan_inta(s1,"SL",sublat[num_sublat],nn);
      num_sublat++; num_sublat%=NSL; /* handle overflow as reset */
    } else
    if(!scan_dbl(s1,"maxmem" ,&r1)){ maxmem=(ULong)r1;} else  
    if(!scan_dbl(s1,"maxfile",&r1)){ hfmax=(ULong)(r1*HBLen/Hsize);
      if( (double)hfmax+1<r1*HBLen/Hsize ) ERR(612);
      } else
    if(!scan_dbl(s1,"xy_anisotropy+",&r1)){ h_xypara+=r1;} else
    if(!scan_dbl(s1,"z_anisotropy+",&r1)){ h_zpara+=r1;} else
    if(!scan_dbl(s1,"xy_anisotropy",&r1)){ h_xypara=r1;} else
    if(!scan_dbl(s1,"z_anisotropy",&r1)){ h_zpara=r1;} else
    if(!scan_int(s1,"verbose",&vvv)){} else
    if(!scan_int(s1,"sisj",&cfg_sisj)){} else
    if( (ss=scan_var(s1,"nud+"  ))!=NULL ){ scan_ud(ss,1); } else
    if( (ss=scan_var(s1,"param+"))!=NULL ){ scan_para(ss,1); } else
    if( (ss=scan_var(s1,"nud"  ))!=NULL ){ scan_ud(ss,0); } else
    if( (ss=scan_var(s1,"param"))!=NULL ){ scan_para(ss,0); } else
    /* allow "p1=-1.0", "p1= -1.0" or " p1= -1.0" as input per line */
    if (sscanf(s1," p%d= %lf",&i1,&r1)==2) {
        para[i1]=r1; printf("set parameter p%d= %f\n",i1,r1); } else
    if(s1[0]=='x'){sscanf(s1,"%*c%d%lu",&x_p,&x_max);} else /* ToDo: replace by function */
    if(s1[0]=='l'){ loadvec(&(ev[0]),s1+1,-1,-1);
    } else
    if(s1[0]==':'){inppara((char *)&s1[1]);} else
    if(strncmp(s1,"newtime",7)==0){starttime=0l;itime();} else	/* reset clock */
    if(strncmp(s1,".out",4)==0){outpara(stdout);} else
    if(strncmp(s1,"pout",4)==0){printf("%s",&s1[4]);} else
    if(s1[0]=='a'){ sscanf(s1,"%*c%d%lu",&algo,&n1max);outpara(stdout);
      /* --- test and if neccessary create Sym symmetries P --- */
      symcreate(Sym); 
      if(vvv&1)testsym();
      CM({if(nu<nd) E0("use nd<nu, that is much faster!");},{},{})
      printf(" nn,nu,nd %d %d %d   nw= %d"
             "  (number of sites, up/down-spins and bounds)\n",nn,nu,nd,nw);
      printf(" k_ud %01d k_T ",(sym.wud<0)?1:0);
      for(i=0;i<sym.numsym;i++)if(sym.g[i])printf("_%01d",sym.k[i]);
      /* ToDo: move output of parameters to a function? */
      printf("\n parameters ");
      //  for (j=0;j<nw;j++){ printf("t[%d]=%d ",j,ww.wt[j]); }
      for(i=1;i<numpara;i++){ int j,k=0;
        /* output human readable names, ex: J1=J2= 0.3 t1= -0.7 ... */
        for (j=0;j<nw;j++) if (ww.wj[j]==i) {printf("J%d=",(k=i)); break;}
        for (j=0;j<nw;j++) if (ww.wt[j]==i) {printf("t%d=",(k=i)); break;}
        for (j=0;j<nw;j++) if (ww.w[j]==i)  {printf("w%d=",(k=i)); break;}
        for (j=0;j<nw;j++) if (ww.wv[j]==i) {printf("V%d=",(k=i)); break;}
        for (j=0;j<nw;j++) if (ww.wh[j]==i) {printf("h%d=",(k=i)); break;}
        for (j=0;j<nn;j++) if (ww.we[j]==i) {printf("e%d=",(k=i)); break;}
        for (j=0;j<nn;j++) if (ww.wu[j]==i) {printf("U%d=",(k=i)); break;}
        for (j=0;j<nn;j++) if (ww.wf[j]==i) {printf("f%d=",(k=i)); break;}
        for (j=0;j<nn;j++) if (ww.wd[j]==i) {printf("D%d=",(k=i)); break;}
        if (!k) printf("p%d=",i); /* unused or unknown parameter */
        printf(" %g  ",(double)para[i]);
      } printf("\n");
      printf(" Bsize=%d t=%s\n",(int)Bsize,sclock(~0l));

	/* ===================== new-method ==================== */
      if(algo&8){
        n1=(n1max)?n1max:1000;	/* n1max<=n1 variiere Basis! */
        b_ini(n1,vvv);
        if((algo&~8)<2){
          for(blk=0;blk<B_NUM;blk++)
          v0.v[blk]=(mcplx *)mymalloc(b_len[blk]*Csize,&m_v0[blk]);
          for(blk=0;blk<B_NUM;blk++)
          v1.v[blk]=(mcplx *)mymalloc(b_len[blk]*Csize,&m_v1[blk]);
        }
        /* l1= (unsigned char *)mymalloc(n1*Bsize,NULL); */
        { fl1=fopen(FILE_l1,"r+b");
          if(!fl1)fl1=fopen(FILE_l1,"w+b"); if(!fl1) F1("fopen %s",FILE_l1);
          l1 = (unsigned char *) mymap(FILE_l1,fl1,(long)n1*Bsize,0);
        }
        for(i=0;i<nev;i++){
          sprintf(s1,FileEV,i);fev[i]=fopen(s1,"r+b");
          if(!fev[i])fev[i]=fopen(s1,"w+b"); if(!fev[i]) F1("fopen %s",s1);
          for(blk=0;blk<B_NUM;blk++)
           ev[i].v[blk] = (mcplx *) mymap(s1,fev[i],(long)(b_len[blk]*Csize),
                                                    (long)(b_ofs[blk]*Csize));
        }
        norm2=(ATnorm2 *)mymalloc(n1*sizeof(ATnorm2),&m_n2);base2ok=0;
        l2b  = (ULong *)mymalloc(n1*Lsize,&m_l2); /* hilfsarray2 */
        n1max=n1;       /* save memory block len before n1 changed */
        storeh2(0);	/* ??? provisorium - testphase */
        /* l2b=(ULong *)myfree((void *) l2b,&m_l2); / * zur Zeit noch!!! */
        randvec(&v1,0);itr=inc1(nev,ne0,&v0,&v1);   /* EW(T),EV(T)  */
        randvec(&v1,0);incv1(nev,&v0,&v1,ev,itr);   /* EV(H)   */
        /* rechnung mit neuem startvector wiederholen */
        if(n1==n1max && nev>0)F0("Fatal, should not break here");
        if (nev) for(j=0;j<nev;j++)chk3(&ev[j],&ev[j],0);
      } else {	/* =================== old-method =================== */
        r1=(double)numconf();
        printf(" nk=%.1e nsym=%d estimated n1: %.1e\n",
          r1,sym.numall+1,r1/(sym.numall+1));
        if( checkpoint<1 ) {
          long l1=itime();
          n1=(ULong)numsymconf(); if(save_mode & 1) wl_status(n1); 
          printf("\n ns.t=%s checkpoint=%d",sclock(itime()-l1),++checkpoint);
        } else rl_status(&n1);
        
        if( n1==0l ) { checkpoint=0; continue; }  /* v1.7.12 */
        
        printf("\n"); b_ini(n1,vvv);	/* block initialization */
        printf(" N %u ud %u %u n1 %lu n2 %lu io %d",
                nn,nu,nd,n1,n2,Ham1 + 2*Ham2 + 4*Ham3);
        printf(" MinMem %.0e",(double)(Dsize*(2l+nev)*n1+Lsize*(n1/* +2l*n2 */)));
        printf(" MaxMem %.0e MaxHfile %.0e\n",
               (double)maxmem,(double)hfmax*(double)Hsize/HBLen);
        if(!n1){E0("n1==0");continue;}
        if(((n1<<1)>>1)!=n1){E0("n1>max");continue;}
        /* --- l1 is probably initialized by numsymconf --- */
        if (!l1)
        /* l1= (unsigned char *)mymalloc(n1*Bsize,NULL); */
        {
          fl1=fopen(FILE_l1,"r+b");
          if(!fl1)fl1=fopen(FILE_l1,"w+b"); if(!fl1) F1("fopen %s",FILE_l1);
          l1 = (unsigned char *) mymap(FILE_l1,fl1,(long)n1*Bsize,0);
        }
        if(algo<2){
          for(blk=0;blk<B_NUM;blk++)
          v0.v[blk]=(mcplx *)mymalloc(b_len[blk]*Csize,&m_v0[blk]);
          for(blk=0;blk<B_NUM;blk++)
          v1.v[blk]=(mcplx *)mymalloc(b_len[blk]*Csize,&m_v1[blk]);
        }
        if((algo==2) && nev<1){ nev=1; E0("nev is 0, set 1"); }
        for(i=0;i<nev;i++){
          sprintf(s1,FileEV,i);fev[i]=fopen(s1,"r+b");
          if(!fev[i])fev[i]=fopen(s1,"w+b"); if(!fev[i]) F1("fopen %s",s1);
          for(blk=0;blk<B_NUM;blk++)
           ev[i].v[blk] = (mcplx *) mymap(s1,fev[i],(long)(b_len[blk]*Csize),
                                                    (long)(b_ofs[blk]*Csize));
        }
  #ifdef SBase
        norm2=(ATnorm2 *)mymalloc(n1*sizeof(ATnorm2),&m_n2);base2ok=0;
  #endif
        /* if( checkpoint < 2 ) */ 
        { /* norm2 is not mapped! change it ??? */
          long l1=itime();
          ini_norm2();
          /* if(save_mode & 1) save_l1(l1,n1,0); --- mmap used */ /* store */ 
          if (checkpoint<2) printf("\n n2.t=%s checkpoint=%d",
                            sclock(itime()-l1), ++checkpoint);
        } /* else load_l1(l1,n1); --- mmap used */
        outbasis(stdout);
        if(algo<3){ storeh(); }
        if(err_fatal){ E0("fatal"); }	/* error => break Mai99 */
        test_all_sym();	/* only array-ov test Mai99 */
        if(algo<2){
          for(blk=0;blk<B_NUM;blk++)if(!v0.v[blk])
          v0.v[blk]=(mcplx *)mymalloc(b_len[blk]*Csize,&m_v0[blk]);
          for(blk=0;blk<B_NUM;blk++)if(!v1.v[blk])
          v1.v[blk]=(mcplx *)mymalloc(b_len[blk]*Csize,&m_v1[blk]);
        }
        /* --- vektor auf platte --- */
        /* iv=5;if(iv==0) */		/* Ausgabe bei Entartung */
        if(!err_fatal)
        for(iv=1;iv<=max_ea;iv++){	/* Nummer des Startvektors   */
          if (iv>1) checkpoint=3;	/* reset checkpoint */
          if(algo==0){	/* pseudo random startvector depends only on iv! */
           /* here is the right place to choose iv2=random instead of iv */
           clrvec(&v1); /* to get local blocks for threads on ccNUMA */
           randvec(&v1,iv+(startvec&4)*2*nruns);
           itr=inc1(nev,ne0,&v0,&v1);                   /* EW(T),EV(T)  */
           if( checkpoint<5 || iv>1 ) {			/* v1.7.14 */
             if(nev){ randvec(&v1,iv+(startvec&4)*2*nruns);
             incv1(nev,&v0,&v1,ev,itr); }               /* EV(H) */
             if ( iv<=1 ) printf(" checkpoint=%d",++checkpoint);
           } else { if(nev>0)loadvec(&ev[0],FileGS,j,-1); }; /* reload */
          } else if(algo==1){
           randvec(&v0,iv+(startvec&4)*2*nruns);
           itr=lanz1(&v0,&v1,&ev[0]);        /* 1-step-lanzcos EW,EV(H) */
          } else if(algo==2 && nev>0){
           randvec(&ev[0],iv+(startvec&4)*2*nruns);
           itr=lanz2(&ev[0]);                /* 2x2-Matrix     EW,EV(H) */
          } else if(algo==3 && nev>0){
            if( loadvec(&ev[0],FileGS,iv,-1) ) continue; /* v1.7.13+ */
          } /* <O> zu H' */
          else if(algo==4){ fulldiag(ev,nev); }		/* full diag = jacobi */
          printf("\n erg="); outew(stdout);
          fprintf(stdout," t=%s",sclock(~0l));
          printf("\n E0/N= %12.8f E0/nw= %12.8f",D(ew[0]/nn),D(ew[0]/nw)); /* Feb99 */
          if (ne0)
          printf("\n E%d/N= %12.8f E%d/nw= %12.8f E%d= %12.8f",ne0,D(ew[ne0]/nn),ne0,D(ew[ne0]/nw),ne0,ew[ne0]); /* Feb99 */
          if(algo==4 || (!nev))break;	
          for(ii=0,j=1;j<iv;j++){ /* orthogonalize ev against saved vectors */
            loadvec(&v0,FileGS,j,-1);
            if((ii=iortho(&ev[0],&v0))==1)break;
          } /* stop if we have found all orthogonal ev's */
          if(ii!=0)break; savevec(&ev[0],FileGS,iv,-1);
          if(nev>1){      savevec(&ev[1],FileEX,iv,-1); }
          if(algo <3)for(j=0;j<nev;j++)chk3(&ev[j],&v1,iv);
          if(algo==3)chk3(&ev[0],&ev[0],iv);/* only Expection Values */
          if(algo==4)for(j=0;j<nev;j++)chk3(&ev[j],&ev[j],iv);
        } 
        printf("\n degree_of_degeneracy=%d<%d\n",iv-1,max_ea);
      }
 /* label_end: */
      if(!err_fatal)
 /*   if(iv>2)chk2(&v0,&v1,iv-1); */    /* output for degeneracy */
      if(stkptr!=0)E0("stkptr!=0");	/* save stack before OV */
      if(stkptr>10)F0("stkptr>10");	/* unbalanced STKa STKe ? */
      norm2=(ATnorm2 *)myfree((void *) norm2, &m_n2);base2ok=0;
      l2b=   (ULong *)myfree((void *) l2b, &m_l2);
      if(algo&8) myunmap(l1,fl1,(long)n1max*Bsize,0);
      else       myunmap(l1,fl1,(long)n1   *Bsize,0);
      fclose(fl1); l1=NULL; fl1=NULL;
      for(i=0;i<nev;i++) {
        for(blk=0;blk<B_NUM;blk++)
          myunmap(ev[i].v[blk],fev[i],(long)(b_len[blk]*Csize),
                                      (long)(b_ofs[blk]*Csize));
        fclose(fev[i]); fev[i]=NULL;
      }
      for(blk=0;blk<B_NUM;blk++) v1.v[blk]=(mcplx *)myfree((void *)v1.v[blk],&m_v1[blk]);
      for(blk=0;blk<B_NUM;blk++) v0.v[blk]=(mcplx *)myfree((void *)v0.v[blk],&m_v0[blk]);
      n1=0l; /* reset n1 */
      checkpoint=0; nruns++;
      printf(" --- next\n");
    }
    if(err_fatal){ err_fatal=0;printf("\n reset err_fatal"); }
  } /* for(;;) */ 
  fclose(in1);printf("\n");
#ifdef CONFIG_PTHREAD
  /* send no further tasks to threads */
  pthread_mutex_lock(&pt_mutex1);
  for (i=0;i<B_NUM;i++) main_pt[i].task=-1;    /* finalize */
  pthread_cond_broadcast(&pt_cond1);
  pthread_mutex_unlock(&pt_mutex1);
#endif
  sub_end();	/* kill child */
#ifdef CONFIG_PTHREAD
  for (i=0;i<B_NUM;i++) {          /* join main threads */
    pthread_join(pt[i],NULL);
  }
#elif defined(CONFIG_MPI)
  MPI_Finalize();
#endif
  return(0);
}

#ifdef F2C
/* lapack-3.0 for linux needs f2c and f2c needs MAIN__() */
/* if you know a better solution, please tell me */
#if (VecType & 4) || defined(__cplusplus)
extern "C"
#endif
int MAIN__(){ return main(0,NULL); }
#endif
